// SPDX-License-Identifier: GPL-2.0
/*
 * Copyright (C) 2023 Spacemit Co., Ltd.
 *
 */

#ifndef _SATURN_REG_MAP_A0_H_
#define _SATURN_REG_MAP_A0_H_

#ifndef UINT32
typedef uint32_t UINT32;
#endif

#ifndef INT32
typedef uint32_t INT32;
#endif

#define SATURN_BASE_ADDR 0x0

#define DPU_TOP_BASE_ADDR 0x0
#define DPU_CTRL_BASE_ADDR 0x500
#define DPU_CRG_BASE_ADDR 0x700
#define CMDLIST_BASE_ADDR 0x800
#define DPU_INT_BASE_ADDR 0x900

#define RDMA_SIZE 0x100
#define DMA_TOP_BASE_ADDR 0xA00
#define RDMA0_BASE_ADDR (DMA_TOP_BASE_ADDR + 0x80)
#define RDMA1_BASE_ADDR (RDMA0_BASE_ADDR + RDMA_SIZE)
#define RDMA2_BASE_ADDR (RDMA1_BASE_ADDR + RDMA_SIZE)
#define RDMA3_BASE_ADDR (RDMA2_BASE_ADDR + RDMA_SIZE)
#define RDMA4_BASE_ADDR (RDMA3_BASE_ADDR + RDMA_SIZE)
#define RDMA5_BASE_ADDR (RDMA4_BASE_ADDR + RDMA_SIZE)
#define RDMA6_BASE_ADDR (RDMA5_BASE_ADDR + RDMA_SIZE)
#define RDMA7_BASE_ADDR (RDMA6_BASE_ADDR + RDMA_SIZE)
#define RDMA8_BASE_ADDR (RDMA7_BASE_ADDR + RDMA_SIZE)
#define RDMA9_BASE_ADDR (RDMA8_BASE_ADDR + RDMA_SIZE)
#define RDMA10_BASE_ADDR (RDMA9_BASE_ADDR + RDMA_SIZE)
#define RDMA11_BASE_ADDR (RDMA10_BASE_ADDR + RDMA_SIZE)
#define RDMA_BASE_ADDR(rdma_id) (RDMA0_BASE_ADDR + rdma_id * RDMA_SIZE)

#define MMU_TBU_SIZE 0x40
#define MMU_TOP_SIZE 0x100
#define MMU_BASE_ADDR (RDMA11_BASE_ADDR + RDMA_SIZE)
#define MMU_TOP_BASE_ADDR (MMU_BASE_ADDR)
#define MMU_TBU_BASE_ADDR (MMU_BASE_ADDR + 0x100)

#define LP_SIZE 0x300
#define LMERGE_SIZE 0x20
#define LP0_BASE_ADDR 0x2000
#define LP1_BASE_ADDR (LP0_BASE_ADDR + LP_SIZE)
#define LP2_BASE_ADDR (LP1_BASE_ADDR + LP_SIZE)
#define LP3_BASE_ADDR (LP2_BASE_ADDR + LP_SIZE)
#define LP4_BASE_ADDR (LP3_BASE_ADDR + LP_SIZE)
#define LP5_BASE_ADDR (LP4_BASE_ADDR + LP_SIZE)
#define LP6_BASE_ADDR (LP5_BASE_ADDR + LP_SIZE)
#define LP7_BASE_ADDR (LP6_BASE_ADDR + LP_SIZE)
#define LP8_BASE_ADDR (LP7_BASE_ADDR + LP_SIZE)
#define LP9_BASE_ADDR (LP8_BASE_ADDR + LP_SIZE)
#define LP10_BASE_ADDR (LP9_BASE_ADDR + LP_SIZE)
#define LP11_BASE_ADDR (LP10_BASE_ADDR + LP_SIZE)
#define LMERGE0_BASE_ADDR (LP11_BASE_ADDR + LP_SIZE)
#define LMERGE1_BASE_ADDR (LMERGE0_BASE_ADDR + LMERGE_SIZE)
#define LMERGE2_BASE_ADDR (LMERGE1_BASE_ADDR + LMERGE_SIZE)
#define LMERGE3_BASE_ADDR (LMERGE2_BASE_ADDR + LMERGE_SIZE)
#define LMERGE4_BASE_ADDR (LMERGE3_BASE_ADDR + LMERGE_SIZE)
#define LMERGE5_BASE_ADDR (LMERGE4_BASE_ADDR + LMERGE_SIZE)
#define LMERGE6_BASE_ADDR (LMERGE5_BASE_ADDR + LMERGE_SIZE)
#define LMERGE7_BASE_ADDR (LMERGE6_BASE_ADDR + LMERGE_SIZE)
#define LMERGE8_BASE_ADDR (LMERGE7_BASE_ADDR + LMERGE_SIZE)
#define LMERGE9_BASE_ADDR (LMERGE8_BASE_ADDR + LMERGE_SIZE)
#define LMERGE10_BASE_ADDR (LMERGE9_BASE_ADDR + LMERGE_SIZE)
#define LMERGE11_BASE_ADDR (LMERGE10_BASE_ADDR + LMERGE_SIZE)

#define CMP_SIZE 0x300
#define CMP0_BASE_ADDR 0x4600
#define CMP1_BASE_ADDR (CMP0_BASE_ADDR + CMP_SIZE)
#define CMP2_BASE_ADDR (CMP1_BASE_ADDR + CMP_SIZE)
#define CMP3_BASE_ADDR (CMP2_BASE_ADDR + CMP_SIZE)
#define CMP_BASE_ADDR(cmp_id) (CMP0_BASE_ADDR + cmp_id * CMP_SIZE)

#define SCALER_SIZE 0x200
#define SCALER0_ONLINE_BASE_ADDR 0x6000
#define SCALER1_ONLINE_BASE_ADDR (SCALER0_ONLINE_BASE_ADDR + SCALER_SIZE)

#define OUTCTRL_SIZE 0x8800
#define OUTCTRL0_BASE_ADDR 0x7000
#define PP0_BASE_ADDR (OUTCTRL0_BASE_ADDR + 0x100)
#define ACAD0_BASE_ADDR (OUTCTRL0_BASE_ADDR + 0x280)
#define LUT3D0_BASE_ADDR (OUTCTRL0_BASE_ADDR + 0x600)
#define DSCA0_BASE_ADDR (OUTCTRL0_BASE_ADDR + 0x8000)
#define DSCB0_BASE_ADDR (OUTCTRL0_BASE_ADDR + 0x8100)

#define OUTCTRL1_BASE_ADDR (OUTCTRL0_BASE_ADDR + OUTCTRL_SIZE)
#define PP1_BASE_ADDR (OUTCTRL1_BASE_ADDR + 0x100)
#define ACAD1_BASE_ADDR (OUTCTRL1_BASE_ADDR + 0x280)
#define LUT3D1_BASE_ADDR (OUTCTRL1_BASE_ADDR + 0x600)
#define DSCA1_BASE_ADDR (OUTCTRL1_BASE_ADDR + 0x8000)
#define DSCB1_BASE_ADDR (OUTCTRL1_BASE_ADDR + 0x8100)

#define OUTCTRL2_BASE_ADDR (OUTCTRL1_BASE_ADDR + OUTCTRL_SIZE)
#define PP2_BASE_ADDR (OUTCTRL2_BASE_ADDR + 0x100)
#define ACAD2_BASE_ADDR (OUTCTRL2_BASE_ADDR + 0x280)
#define LUT3D2_BASE_ADDR (OUTCTRL2_BASE_ADDR + 0x600)
#define DSCA2_BASE_ADDR (OUTCTRL2_BASE_ADDR + 0x8000)
#define DSCB2_BASE_ADDR (OUTCTRL2_BASE_ADDR + 0x8100)

#define OUTCTRL3_BASE_ADDR (OUTCTRL2_BASE_ADDR + OUTCTRL_SIZE)
#define PP3_BASE_ADDR (OUTCTRL3_BASE_ADDR + 0x100)
#define ACAD3_BASE_ADDR (OUTCTRL3_BASE_ADDR + 0x280)
#define LUT3D3_BASE_ADDR (OUTCTRL3_BASE_ADDR + 0x600)
#define DSCA3_BASE_ADDR (OUTCTRL3_BASE_ADDR + 0x8000)
#define DSCB3_BASE_ADDR (OUTCTRL3_BASE_ADDR + 0x8100)
#define OUTCTRL_BASE_ADDR(ctrl_id) (OUTCTRL0_BASE_ADDR + OUTCTRL_SIZE * ctrl_id)

#define WB_SIZE 0x400
#define WB0_TOP_BASE_ADDR 0x29000
#define WB0_SCALER_BASE_ADDR (WB0_TOP_BASE_ADDR + 0x200)
#define WB1_TOP_BASE_ADDR (WB0_TOP_BASE_ADDR + WB_SIZE)
#define WB1_SCALER_BASE_ADDR (WB1_TOP_BASE_ADDR + 0x200)

#define SATURN_SIZE 0x2A000

#include "cmdlist.h"
#include "cmps_x.h"
#include "dma_top.h"
#include "dpu_crg.h"
#include "dpu_ctl.h"
#include "dpu_intp.h"
#include "dpu_top.h"
#include "mmu.h"
#include "outctrl_top_x.h"
#include "outctrl_proc_x.h"
#include "rdma_path_x.h"
#include "scaler_x.h"
#include "wb_top.h"
#include "prepipe_layer_proc_x.h"

#endif
