
/* SPDX-License-Identifier: GPL-2.0 */
/* THIS FILE WAS AUTOGENERATED BY jevents.py arch=riscv model=all ! */

#include <pmu-events/pmu-events.h>
#include "util/header.h"
#include "util/pmu.h"
#include <string.h>
#include <stddef.h>

struct compact_pmu_event {
        int offset;
};

struct pmu_table_entry {
        const struct compact_pmu_event *entries;
        uint32_t num_entries;
        struct compact_pmu_event pmu_name;
};

static const char *const big_c_string =
/* offset=0 */ "tool\000"
/* offset=5 */ "duration_time\000tool\000Wall clock interval time in nanoseconds\000config=1\000\00000\000\000"
/* offset=78 */ "user_time\000tool\000User (non-kernel) time in nanoseconds\000config=2\000\00000\000\000"
/* offset=145 */ "system_time\000tool\000System/kernel time in nanoseconds\000config=3\000\00000\000\000"
/* offset=210 */ "has_pmem\000tool\0001 if persistent memory installed otherwise 0\000config=4\000\00000\000\000"
/* offset=283 */ "num_cores\000tool\000Number of cores. A core consists of 1 or more thread, with each thread being associated with a logical Linux CPU\000config=5\000\00000\000\000"
/* offset=425 */ "num_cpus\000tool\000Number of logical Linux CPUs. There may be multiple such CPUs on a core\000config=6\000\00000\000\000"
/* offset=525 */ "num_cpus_online\000tool\000Number of online logical Linux CPUs. There may be multiple such CPUs on a core\000config=7\000\00000\000\000"
/* offset=639 */ "num_dies\000tool\000Number of dies. Each die has 1 or more cores\000config=8\000\00000\000\000"
/* offset=712 */ "num_packages\000tool\000Number of packages. Each package has 1 or more die\000config=9\000\00000\000\000"
/* offset=795 */ "slots\000tool\000Number of functional units that in parallel can execute parts of an instruction\000config=0xa\000\00000\000\000"
/* offset=902 */ "smt_on\000tool\0001 if simultaneous multithreading (aka hyperthreading) is enable otherwise 0\000config=0xb\000\00000\000\000"
/* offset=1006 */ "system_tsc_freq\000tool\000The amount a Time Stamp Counter (TSC) increases per second\000config=0xc\000\00000\000\000"
/* offset=1102 */ "default_core\000"
/* offset=1115 */ "fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000"
/* offset=1221 */ "fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000"
/* offset=1330 */ "fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000"
/* offset=1424 */ "fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000"
/* offset=1521 */ "fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000"
/* offset=1632 */ "fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000"
/* offset=1716 */ "fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000"
/* offset=1825 */ "fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000"
/* offset=1950 */ "fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000"
/* offset=2087 */ "fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000"
/* offset=2240 */ "fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000"
/* offset=2386 */ "fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000"
/* offset=2548 */ "fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000"
/* offset=2719 */ "fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000"
/* offset=2906 */ "fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000"
/* offset=3055 */ "fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000"
/* offset=3220 */ "fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000"
/* offset=3394 */ "fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000"
/* offset=3584 */ "fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000"
/* offset=3733 */ "fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000"
/* offset=3898 */ "fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000"
/* offset=4072 */ "fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000"
/* offset=4262 */ "cycle_count\000instructions\000Cycle count\000event=0x10\000\00000\000\000"
/* offset=4315 */ "inst_count\000instructions\000Retired instruction count\000event=0x20\000\00000\000\000"
/* offset=4381 */ "int_load_inst\000instructions\000Integer load instruction count\000event=0x30\000\00000\000\000"
/* offset=4455 */ "int_store_inst\000instructions\000Integer store instruction count\000event=0x40\000\00000\000\000"
/* offset=4531 */ "atomic_inst\000instructions\000Atomic instruction count\000event=0x50\000\00000\000\000"
/* offset=4597 */ "sys_inst\000instructions\000System instruction count\000event=0x60\000\00000\000\000"
/* offset=4660 */ "int_compute_inst\000instructions\000Integer computational instruction count\000event=0x70\000\00000\000\000"
/* offset=4746 */ "condition_br\000instructions\000Conditional branch instruction count\000event=0x80\000\00000\000\000"
/* offset=4825 */ "taken_condition_br\000instructions\000Taken conditional branch instruction count\000event=0x90\000\00000\000\000"
/* offset=4916 */ "jal_inst\000instructions\000JAL instruction count\000event=0xa0\000\00000\000\000"
/* offset=4976 */ "jalr_inst\000instructions\000JALR instruction count\000event=0xb0\000\00000\000\000"
/* offset=5038 */ "ret_inst\000instructions\000Return instruction count\000event=0xc0\000\00000\000\000"
/* offset=5101 */ "control_trans_inst\000instructions\000Control transfer instruction count\000event=0xd0\000\00000\000\000"
/* offset=5184 */ "ex9_inst\000instructions\000EXEC.IT instruction count\000event=0xe0\000\00000\000\000"
/* offset=5248 */ "int_mul_inst\000instructions\000Integer multiplication instruction count\000event=0xf0\000\00000\000\000"
/* offset=5331 */ "int_div_rem_inst\000instructions\000Integer division/remainder instruction count\000event=0x100\000\00000\000\000"
/* offset=5423 */ "float_load_inst\000instructions\000Floating-point load instruction count\000event=0x110\000\00000\000\000"
/* offset=5507 */ "float_store_inst\000instructions\000Floating-point store instruction count\000event=0x120\000\00000\000\000"
/* offset=5593 */ "float_add_sub_inst\000instructions\000Floating-point addition/subtraction instruction count\000event=0x130\000\00000\000\000"
/* offset=5696 */ "float_mul_inst\000instructions\000Floating-point multiplication instruction count\000event=0x140\000\00000\000\000"
/* offset=5789 */ "float_fused_muladd_inst\000instructions\000Floating-point fused multiply-add instruction count\000event=0x150\000\00000\000\000"
/* offset=5895 */ "float_div_sqrt_inst\000instructions\000Floating-point division or square-root instruction count\000event=0x160\000\00000\000\000"
/* offset=6002 */ "other_float_inst\000instructions\000Other floating-point instruction count\000event=0x170\000\00000\000\000"
/* offset=6088 */ "int_mul_add_sub_inst\000instructions\000Integer multiplication and add/sub instruction count\000event=0x180\000\00000\000\000"
/* offset=6192 */ "retired_ops\000instructions\000Retired operation count\000event=0x190\000\00000\000\000"
/* offset=6258 */ "ilm_access\000memory\000ILM access\000event=1\000\00000\000\000"
/* offset=6300 */ "dlm_access\000memory\000DLM access\000event=0x11\000\00000\000\000"
/* offset=6345 */ "icache_access\000memory\000ICACHE access\000event=0x21\000\00000\000\000"
/* offset=6396 */ "icache_miss\000memory\000ICACHE miss\000event=0x31\000\00000\000\000"
/* offset=6443 */ "dcache_access\000memory\000DCACHE access\000event=0x41\000\00000\000\000"
/* offset=6494 */ "dcache_miss\000memory\000DCACHE miss\000event=0x51\000\00000\000\000"
/* offset=6541 */ "dcache_load_access\000memory\000DCACHE load access\000event=0x61\000\00000\000\000"
/* offset=6602 */ "dcache_load_miss\000memory\000DCACHE load miss\000event=0x71\000\00000\000\000"
/* offset=6659 */ "dcache_store_access\000memory\000DCACHE store access\000event=0x81\000\00000\000\000"
/* offset=6722 */ "dcache_store_miss\000memory\000DCACHE store miss\000event=0x91\000\00000\000\000"
/* offset=6781 */ "dcache_wb\000memory\000DCACHE writeback\000event=0xa1\000\00000\000\000"
/* offset=6831 */ "cycle_wait_icache_fill\000microarch\000Cycles waiting for ICACHE fill data\000event=0xb1\000\00000\000\000"
/* offset=6916 */ "cycle_wait_dcache_fill\000microarch\000Cycles waiting for DCACHE fill data\000event=0xc1\000\00000\000\000"
/* offset=7001 */ "uncached_ifetch_from_bus\000microarch\000Uncached ifetch data access from bus\000event=0xd1\000\00000\000\000"
/* offset=7089 */ "uncached_load_from_bus\000microarch\000Uncached load data access from bus\000event=0xe1\000\00000\000\000"
/* offset=7173 */ "cycle_wait_uncached_ifetch\000microarch\000Cycles waiting for uncached ifetch data from bus\000event=0xf1\000\00000\000\000"
/* offset=7275 */ "cycle_wait_uncached_load\000microarch\000Cycles waiting for uncached load data from bus\000event=0x101\000\00000\000\000"
/* offset=7374 */ "main_itlb_access\000microarch\000Main ITLB access\000event=0x111\000\00000\000\000"
/* offset=7435 */ "main_itlb_miss\000microarch\000Main ITLB miss\000event=0x121\000\00000\000\000"
/* offset=7492 */ "main_dtlb_access\000microarch\000Main DTLB access\000event=0x131\000\00000\000\000"
/* offset=7553 */ "main_dtlb_miss\000microarch\000Main DTLB miss\000event=0x141\000\00000\000\000"
/* offset=7610 */ "cycle_wait_itlb_fill\000microarch\000Cycles waiting for Main ITLB fill data\000event=0x151\000\00000\000\000"
/* offset=7697 */ "pipe_stall_cycle_dtlb_miss\000microarch\000Pipeline stall cycles caused by Main DTLB miss\000event=0x161\000\00000\000\000"
/* offset=7798 */ "mispredict_condition_br\000microarch\000Misprediction of conditional branches\000event=2\000\00000\000\000"
/* offset=7883 */ "mispredict_take_condition_br\000microarch\000Misprediction of taken conditional branches\000event=0x12\000\00000\000\000"
/* offset=7982 */ "mispredict_target_ret_inst\000microarch\000Misprediction of targets of Return instructions\000event=0x22\000\00000\000\000"
/* offset=8083 */ "exception_taken\000instruction\000Counts exceptions taken\000event=0x100\000\00000\000\000"
/* offset=8152 */ "integer_load_retired\000instruction\000Counts integer load instructions retired\000event=0x200\000\00000\000\000"
/* offset=8243 */ "integer_store_retired\000instruction\000Counts integer store instructions retired\000event=0x400\000\00000\000\000"
/* offset=8336 */ "atomic_memory_retired\000instruction\000Counts atomic memory instructions retired\000event=0x800\000\00000\000\000"
/* offset=8429 */ "system_instruction_retired\000instruction\000Counts system instructions retired (CSR, WFI, MRET, etc.)\000event=0x1000\000\00000\000\000"
/* offset=8544 */ "integer_arithmetic_retired\000instruction\000Counts integer arithmetic instructions retired\000event=0x2000\000\00000\000\000"
/* offset=8648 */ "conditional_branch_retired\000instruction\000Counts conditional branch instructions retired\000event=0x4000\000\00000\000\000"
/* offset=8752 */ "jal_instruction_retired\000instruction\000Counts jump-and-link instructions retired\000event=0x8000\000\00000\000\000"
/* offset=8848 */ "jalr_instruction_retired\000instruction\000Counts indirect jump instructions (JALR) retired\000event=0x10000\000\00000\000\000"
/* offset=8953 */ "integer_multiplication_retired\000instruction\000Counts integer multiplication instructions retired\000event=0x20000\000\00000\000\000"
/* offset=9066 */ "integer_division_retired\000instruction\000Counts integer division instructions retired\000event=0x40000\000\00000\000\000"
/* offset=9167 */ "fp_load_retired\000instruction\000Counts floating-point load instructions retired\000event=0x80000\000\00000\000\000"
/* offset=9262 */ "fp_store_retired\000instruction\000Counts floating-point store instructions retired\000event=0x100000\000\00000\000\000"
/* offset=9360 */ "fp_add_retired\000instruction\000Counts floating-point add instructions retired\000event=0x200000\000\00000\000\000"
/* offset=9454 */ "fp_mul_retired\000instruction\000Counts floating-point multiply instructions retired\000event=0x400000\000\00000\000\000"
/* offset=9553 */ "fp_muladd_retired\000instruction\000Counts floating-point fused multiply-add instructions retired\000event=0x800000\000\00000\000\000"
/* offset=9665 */ "fp_div_sqrt_retired\000instruction\000Counts floating point divide or square root instructions retired\000event=0x1000000\000\00000\000\000"
/* offset=9783 */ "other_fp_retired\000instruction\000Counts other floating-point instructions retired\000event=0x2000000\000\00000\000\000"
/* offset=9882 */ "icache_miss\000memory\000Counts instruction cache misses\000event=0x102\000\00000\000\000"
/* offset=9950 */ "dcache_miss\000memory\000Counts data cache misses\000event=0x202\000\00000\000\000"
/* offset=10011 */ "dcache_release\000memory\000Counts writeback requests from the data cache\000event=0x402\000\00000\000\000"
/* offset=10096 */ "itlb_miss\000memory\000Counts Instruction TLB misses caused by instruction address translation requests\000event=0x802\000\00000\000\000"
/* offset=10211 */ "dtlb_miss\000memory\000Counts Data TLB misses caused by data address translation requests\000event=0x1002\000\00000\000\000"
/* offset=10313 */ "utlb_miss\000memory\000Counts Unified TLB misses caused by address translation requests\000event=0x2002\000\00000\000\000"
/* offset=10413 */ "addressgen_interlock\000microarch\000Counts cycles with an address-generation interlock\000event=0x101\000\00000\000\000"
/* offset=10512 */ "longlatency_interlock\000microarch\000Counts cycles with a long-latency interlock\000event=0x201\000\00000\000\000"
/* offset=10605 */ "csr_interlock\000microarch\000Counts cycles with a CSR interlock\000event=0x401\000\00000\000\000"
/* offset=10681 */ "icache_blocked\000microarch\000Counts cycles in which the instruction cache was not able to provide an instruction\000event=0x801\000\00000\000\000"
/* offset=10807 */ "dcache_blocked\000microarch\000Counts cycles in which the data cache blocked an instruction\000event=0x1001\000\00000\000\000"
/* offset=10911 */ "branch_direction_misprediction\000microarch\000Counts mispredictions of conditional branch direction (taken/not taken)\000event=0x2001\000\00000\000\000"
/* offset=11042 */ "branch_target_misprediction\000microarch\000Counts mispredictions of the target PC of control-flow instructions\000event=0x4001\000\00000\000\000"
/* offset=11166 */ "pipeline_flush\000microarch\000Counts flushes of the core pipeline. Common causes include fence.i and CSR accesses\000event=0x8001\000\00000\000\000"
/* offset=11293 */ "replay\000microarch\000Counts instruction replays\000event=0x10001\000\00000\000\000"
/* offset=11356 */ "integer_mul_div_interlock\000microarch\000Counts cycles with a multiply or divide interlock\000event=0x20001\000\00000\000\000"
/* offset=11461 */ "fp_interlock\000microarch\000Counts cycles with a floating-point interlock\000event=0x40001\000\00000\000\000"
/* offset=11549 */ "core_clock_cycles\000cycle and instruction count\000Counts core clock cycles\000event=0x165\000\00000\000\000"
/* offset=11637 */ "instructions_retired\000cycle and instruction count\000Counts instructions retired\000event=0x265\000\00000\000\000"
/* offset=11731 */ "trace_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to backpressure from the Trace Encoder\000event=0x80001\000\00000\000\000"
/* offset=11867 */ "watchpoint_0\000watchpoint\000Counts occurrences of watchpoint 0 with action=8\000event=0x164\000\00000\000\000"
/* offset=11957 */ "watchpoint_1\000watchpoint\000Counts occurrences of watchpoint 1 with action=8\000event=0x264\000\00000\000\000"
/* offset=12047 */ "watchpoint_2\000watchpoint\000Counts occurrences of watchpoint 2 with action=8\000event=0x464\000\00000\000\000"
/* offset=12137 */ "watchpoint_3\000watchpoint\000Counts occurrences of watchpoint 3 with action=8\000event=0x864\000\00000\000\000"
/* offset=12227 */ "watchpoint_4\000watchpoint\000Counts occurrences of watchpoint 4 with action=8\000event=0x1064\000\00000\000\000"
/* offset=12318 */ "watchpoint_5\000watchpoint\000Counts occurrences of watchpoint 5 with action=8\000event=0x2064\000\00000\000\000"
/* offset=12409 */ "watchpoint_6\000watchpoint\000Counts occurrences of watchpoint 6 with action=8\000event=0x4064\000\00000\000\000"
/* offset=12500 */ "watchpoint_7\000watchpoint\000Counts occurrences of watchpoint 7 with action=8\000event=0x8064\000\00000\000\000"
/* offset=12591 */ "itlb_miss_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to ITLB Miss\000event=0x100001\000\00000\000\000"
/* offset=12706 */ "dtlb_miss_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to DTLB Miss\000event=0x200001\000\00000\000\000"
/* offset=12821 */ "utlb_hit\000memory\000Counts Unified TLB hits for address translation requests\000event=0x4002\000\00000\000\000"
/* offset=12912 */ "pte_cache_miss\000memory\000Counts Page Table Entry cache misses\000event=0x8002\000\00000\000\000"
/* offset=12989 */ "pte_cache_hit\000memory\000Counts Page Table Entry cache hits\000event=0x10002\000\00000\000\000"
/* offset=13064 */ "itlb_multi_hit\000memory\000Counts Instruction TLB multi-hits\000event=0x20002\000\00000\000\000"
/* offset=13139 */ "dtlb_multi_hit\000memory\000Counts Data TLB multi-hits\000event=0x40002\000\00000\000\000"
/* offset=13207 */ "cond_br_inst\000branch\000Conditional branch instructions\000event=1\000\00000\000\000"
/* offset=13272 */ "cond_br_mispred\000branch\000Conditional branch mispredictions\000event=2\000\00000\000\000"
/* offset=13342 */ "br_inst\000branch\000Branch instructions\000event=0x3c\000\00000\000\000"
/* offset=13393 */ "uncond_br_inst\000branch\000Unconditional branch instructions\000event=0x3d\000\00000\000\000"
/* offset=13465 */ "indirect_br_inst\000branch\000Indirect branch instructions\000event=0x3e\000\00000\000\000"
/* offset=13534 */ "indirect_br_mispred\000branch\000Indirect branch mispredictions\000event=0x42\000\00000\000\000"
/* offset=13608 */ "br_mispred\000branch\000Branch mispredictions\000event=0x45\000\00000\000\000"
/* offset=13664 */ "uncond_br_mispred\000branch\000Unconditional branch mispredictions\000event=0x46\000\00000\000\000"
/* offset=13741 */ "taken_br_mispred\000branch\000Taken branch mispredictions\000event=0x47\000\00000\000\000"
/* offset=13809 */ "taken_cond_br_inst\000branch\000Taken conditional branch instructions\000event=0x48\000\00000\000\000"
/* offset=13889 */ "taken_cond_br_mispred\000branch\000Taken conditional branch mispredictions\000event=0x49\000\00000\000\000"
/* offset=13974 */ "long_jump\000branch\000Long jumps\000event=0x4a\000\00000\000\000"
/* offset=14018 */ "l1d_load_miss\000cache\000L1 D-cache load misses\000event=5\000\00000\000\000"
/* offset=14074 */ "l1d_load_access\000cache\000L1 D-cache load accesses\000event=6\000\00000\000\000"
/* offset=14134 */ "l1d_store_miss\000cache\000L1 D-cache store misses\000event=9\000\00000\000\000"
/* offset=14192 */ "l1d_store_access\000cache\000L1 D-cache store accesses\000event=0xa\000\00000\000\000"
/* offset=14256 */ "l1i_load_miss\000cache\000L1 I-cache load misses\000event=0xb\000\00000\000\000"
/* offset=14314 */ "l1i_load_access\000cache\000L1 I-cache load accesses\000event=0xc\000\00000\000\000"
/* offset=14376 */ "l1i_prefetch_miss\000cache\000L1 I-cache prefetch misses\000event=0xd\000\00000\000\000"
/* offset=14442 */ "l1i_prefetch\000cache\000L1 I-cache prefetches\000event=0xe\000\00000\000\000"
/* offset=14498 */ "dtlb_load_miss\000cache\000DTLB load misses\000event=0x15\000\00000\000\000"
/* offset=14552 */ "dtlb_store_miss\000cache\000DTLB store misses\000event=0x19\000\00000\000\000"
/* offset=14608 */ "itlb_load_miss\000cache\000ITLB load misses\000event=0x1b\000\00000\000\000"
/* offset=14662 */ "jtlb_miss\000cache\000JTLB misses\000event=0xa3\000\00000\000\000"
/* offset=14706 */ "l1d_access\000cache\000L1 D-cache accesses\000event=0xaa\000\00000\000\000"
/* offset=14759 */ "l1d_miss\000cache\000L1 D-cache misses\000event=0xab\000\00000\000\000"
/* offset=14808 */ "l1d_excl_evict\000cache\000L1 D-cache exclusive evictions to L2\000event=0xac\000\00000\000\000"
/* offset=14882 */ "l1d_amr_active\000cache\000L1 D-cache AMR actives\000event=0xad\000\00000\000\000"
/* offset=14942 */ "l1d_prefetch_refill\000cache\000L1 D-cache prefetch refills\000event=0xae\000\00000\000\000"
/* offset=15012 */ "l1d_prefetch_hit\000cache\000L1 D-cache prefetch hits\000event=0xaf\000\00000\000\000"
/* offset=15076 */ "l2_access\000cache\000L2 cache accesses\000event=0xb8\000\00000\000\000"
/* offset=15126 */ "l2_miss\000cache\000L2 cache misses\000event=0xb9\000\00000\000\000"
/* offset=15172 */ "l2_load_access\000cache\000L2 cache load accesses\000event=0xba\000\00000\000\000"
/* offset=15232 */ "l2_load_stall\000cache\000L2 cache load stalls\000event=0xbb\000\00000\000\000"
/* offset=15289 */ "l2_store_access\000cache\000L2 cache store accesses\000event=0xbc\000\00000\000\000"
/* offset=15351 */ "l2_store_stall\000cache\000L2 cache store stalls\000event=0xbd\000\00000\000\000"
/* offset=15410 */ "alu_inst\000instruction\000ALU (integer) instructions\000event=0x24\000\00000\000\000"
/* offset=15474 */ "mult_inst\000instruction\000Multiplication instructions\000event=0x25\000\00000\000\000"
/* offset=15540 */ "div_inst\000instruction\000Division instructions\000event=0x26\000\00000\000\000"
/* offset=15599 */ "vector_div_inst\000instruction\000Vector division instructions\000event=0x27\000\00000\000\000"
/* offset=15672 */ "fp_div_inst\000instruction\000Floating-point division instructions\000event=0x28\000\00000\000\000"
/* offset=15749 */ "csr_inst\000instruction\000CSR instructions\000event=0x29\000\00000\000\000"
/* offset=15803 */ "ecall_inst\000instruction\000ECALL instructions\000event=0x2a\000\00000\000\000"
/* offset=15861 */ "fp_inst\000instruction\000Floating-point instructions\000event=0x2b\000\00000\000\000"
/* offset=15925 */ "store_inst\000instruction\000Store instructions\000event=0x2c\000\00000\000\000"
/* offset=15983 */ "load_inst\000instruction\000Load instructions\000event=0x2d\000\00000\000\000"
/* offset=16039 */ "unaligned_load_inst\000instruction\000Unaligned load instructions\000event=0x2e\000\00000\000\000"
/* offset=16115 */ "unaligned_store_inst\000instruction\000Unaligned store instructions\000event=0x2f\000\00000\000\000"
/* offset=16193 */ "atomic_inst\000instruction\000Atomic instructions\000event=0x30\000\00000\000\000"
/* offset=16253 */ "lr_inst\000instruction\000LR instructions\000event=0x31\000\00000\000\000"
/* offset=16305 */ "sc_inst\000instruction\000SC instructions\000event=0x32\000\00000\000\000"
/* offset=16357 */ "amo_inst\000instruction\000AMO instructions\000event=0x33\000\00000\000\000"
/* offset=16411 */ "fence_inst\000instruction\000FENCE instructions\000event=0x34\000\00000\000\000"
/* offset=16469 */ "failed_sc_inst\000instruction\000Failed SC instructions\000event=0x35\000\00000\000\000"
/* offset=16535 */ "bus_fence_inst\000instruction\000Bus FENCE instructions\000event=0x36\000\00000\000\000"
/* offset=16601 */ "fp_load_inst\000instruction\000Floating-point load instructions\000event=0x37\000\00000\000\000"
/* offset=16675 */ "fp_store_inst\000instruction\000Floating-point store instructions\000event=0x38\000\00000\000\000"
/* offset=16751 */ "vector_load_inst\000instruction\000Vector load instructions\000event=0x39\000\00000\000\000"
/* offset=16821 */ "vector_store_inst\000instruction\000Vector store instructions\000event=0x3a\000\00000\000\000"
/* offset=16893 */ "vector_inst\000instruction\000Vector instructions\000event=0x3b\000\00000\000\000"
/* offset=16953 */ "stalled_cycle_frontend\000microarch\000Stalled cycles frontend\000event=3\000\00000\000\000"
/* offset=17023 */ "stalled_cycle_backend\000microarch\000Stalled cycles backend\000event=4\000\00000\000\000"
/* offset=17091 */ "m_mode_cycle\000microarch\000M-mode cycles\000event=0x20\000\00000\000\000"
/* offset=17144 */ "s_mode_cycle\000microarch\000S-mode cycles\000event=0x21\000\00000\000\000"
/* offset=17197 */ "u_mode_cycle\000microarch\000U-mode cycles\000event=0x22\000\00000\000\000"
/* offset=17250 */ "pipeline_flush\000microarch\000Pipeline flushes\000event=0x3f\000\00000\000\000"
/* offset=17308 */ "interrupt\000microarch\000Interrupts\000event=0x40\000\00000\000\000"
/* offset=17355 */ "exception\000microarch\000Exceptions\000event=0x41\000\00000\000\000"
/* offset=17402 */ "ifu_btb_miss\000microarch\000IFU (Instruction Fetch Unit) BTB misses\000event=0x43\000\00000\000\000"
/* offset=17481 */ "ifu_btb_access\000microarch\000IFU (Instruction Fetch Unit) BTB accesses\000event=0x44\000\00000\000\000"
/* offset=17564 */ "ecc_interrupt\000microarch\000ECC interrupts\000event=0x4b\000\00000\000\000"
/* offset=17619 */ "async_abort\000microarch\000Asynchronous aborts\000event=0x4c\000\00000\000\000"
/* offset=17677 */ "issued_inst\000microarch\000Issued instructions\000event=0x4d\000\00000\000\000"
/* offset=17735 */ "if_stall\000microarch\000IF stalls\000event=0x4e\000\00000\000\000"
/* offset=17780 */ "if_mmu_stall\000microarch\000IF-MMU stalls\000event=0x4f\000\00000\000\000"
/* offset=17833 */ "if_refill_stall\000microarch\000IF-refill stalls\000event=0x50\000\00000\000\000"
/* offset=17892 */ "ip_stall\000microarch\000IP stalls\000event=0x51\000\00000\000\000"
/* offset=17937 */ "ib_stall\000microarch\000IB stalls\000event=0x52\000\00000\000\000"
/* offset=17982 */ "ib_vsetvl_stall\000microarch\000IB vsetvl stalls\000event=0x53\000\00000\000\000"
/* offset=18041 */ "ib_fifo_stall\000microarch\000IB FIFO stalls\000event=0x54\000\00000\000\000"
/* offset=18096 */ "ib_mispred_stall\000microarch\000IB misprediction stalls\000event=0x55\000\00000\000\000"
/* offset=18163 */ "ib_ind_btd_stall\000microarch\000IB IND BTB stalls\000event=0x56\000\00000\000\000"
/* offset=18224 */ "iq_full\000microarch\000IQ fulls\000event=0x57\000\00000\000\000"
/* offset=18267 */ "id_stall\000microarch\000ID stalls\000event=0x58\000\00000\000\000"
/* offset=18312 */ "id_inst_pipedown\000microarch\000ID instruction pipedowns\000event=0x59\000\00000\000\000"
/* offset=18380 */ "id_one_inst_pipedown\000microarch\000ID one instruction pipedowns\000event=0x5a\000\00000\000\000"
/* offset=18456 */ "id_flush_stall\000microarch\000ID flush stalls\000event=0x5b\000\00000\000\000"
/* offset=18513 */ "id_vsetvl_fof_stall\000microarch\000 \000event=0x5c\000\00000\000\000"
/* offset=18561 */ "id_iid_not_vld_stall\000microarch\000 \000event=0x5d\000\00000\000\000"
/* offset=18610 */ "id_csr_bef_fence_stall\000microarch\000 \000event=0x5e\000\00000\000\000"
/* offset=18661 */ "id_mispred_stall\000microarch\000ID misprediction stalls\000event=0x5f\000\00000\000\000"
/* offset=18728 */ "rf_stall\000microarch\000RF stalls\000event=0x60\000\00000\000\000"
/* offset=18773 */ "rf_inst_pipedown\000microarch\000RF instruction pipedowns\000event=0x61\000\00000\000\000"
/* offset=18841 */ "rf_one_inst_pipedown\000microarch\000RF one instruction pipedowns\000event=0x62\000\00000\000\000"
/* offset=18917 */ "rf_waw_stall\000microarch\000RF WAW stalls\000event=0x63\000\00000\000\000"
/* offset=18970 */ "rf_raw_stall\000microarch\000RF RAW stalls\000event=0x64\000\00000\000\000"
/* offset=19023 */ "rf_csr_aft_fence_stall\000microarch\000 \000event=0x65\000\00000\000\000"
/* offset=19074 */ "rf_structure_stall\000microarch\000 \000event=0x66\000\00000\000\000"
/* offset=19121 */ "eu_stall\000microarch\000EU (Execution Unit) stalls\000event=0x67\000\00000\000\000"
/* offset=19183 */ "eu_iu_full\000microarch\000EU IU (Integer Unit) fulls\000event=0x68\000\00000\000\000"
/* offset=19247 */ "eu_iu_control_full\000microarch\000EU IU (Integer Unit) control fulls\000event=0x69\000\00000\000\000"
/* offset=19327 */ "eu_bju_full\000microarch\000EU BJU (Branch and Jump Unit) fulls\000event=0x6a\000\00000\000\000"
/* offset=19401 */ "eu_lsu_load_full\000microarch\000EU LSU (Load and Store Unit) load fulls\000event=0x6b\000\00000\000\000"
/* offset=19484 */ "eu_lsu_store_full\000microarch\000EU LSU (Load and Store Unit) store fulls\000event=0x6c\000\00000\000\000"
/* offset=19569 */ "eu_cp0_full\000microarch\000EU CP0 (Coprocessor 0) fulls\000event=0x6d\000\00000\000\000"
/* offset=19636 */ "eu_vfpu_full\000microarch\000EU VFPU (Vector and Floating-point Processing Unit)\000event=0x6e\000\00000\000\000"
/* offset=19727 */ "iu_dp_stall_pipe0\000microarch\000 \000event=0x6f\000\00000\000\000"
/* offset=19773 */ "iu_mult_stall_pipe0\000microarch\000 \000event=0x70\000\00000\000\000"
/* offset=19821 */ "iu_div_ex1_stall_pipe0\000microarch\000 \000event=0x71\000\00000\000\000"
/* offset=19872 */ "iu_dp_pipe_stall_pipe1\000microarch\000 \000event=0x72\000\00000\000\000"
/* offset=19923 */ "iu_mult_stall_pipe1\000microarch\000 \000event=0x73\000\00000\000\000"
/* offset=19971 */ "iu_div_ex1_stall_pipe1\000microarch\000 \000event=0x74\000\00000\000\000"
/* offset=20022 */ "iu_dp_uncommit_pipe0\000microarch\000 \000event=0x75\000\00000\000\000"
/* offset=20071 */ "iu_dp_wb_conflict_pipe0\000microarch\000 \000event=0x76\000\00000\000\000"
/* offset=20123 */ "iu_dp_waw_stall_pipe0\000microarch\000 \000event=0x77\000\00000\000\000"
/* offset=20173 */ "iu_dp_uncommit_pipe1\000microarch\000 \000event=0x78\000\00000\000\000"
/* offset=20222 */ "iu_dp_wb_conflict_pipe1\000microarch\000 \000event=0x79\000\00000\000\000"
/* offset=20274 */ "iu_dp_waw_stall_pipe1\000microarch\000 \000event=0x7a\000\00000\000\000"
/* offset=20324 */ "iu_mult_wb_stall\000microarch\000 \000event=0x7b\000\00000\000\000"
/* offset=20369 */ "iu_mult_uncommit\000microarch\000 \000event=0x7c\000\00000\000\000"
/* offset=20414 */ "iu_div_wb_stall\000microarch\000 \000event=0x7d\000\00000\000\000"
/* offset=20458 */ "iu_div_uncommit\000microarch\000 \000event=0x7e\000\00000\000\000"
/* offset=20502 */ "mult_inner_forward\000microarch\000 \000event=0x7f\000\00000\000\000"
/* offset=20549 */ "div_buffer_hit\000microarch\000 \000event=0x80\000\00000\000\000"
/* offset=20592 */ "vpu_stall_pipe0\000microarch\000VPU (Vector Processing Unit) pipe0 stalls\000event=0x81\000\00000\000\000"
/* offset=20676 */ "vpu_stall_pipe1\000microarch\000VPU (Vector Processing Unit) pipe1 stalls\000event=0x82\000\00000\000\000"
/* offset=20760 */ "vpu_hazard_stall_pipe0\000microarch\000 \000event=0x83\000\00000\000\000"
/* offset=20811 */ "vpu_uncommit_stall_pipe0\000microarch\000 \000event=0x84\000\00000\000\000"
/* offset=20864 */ "vpu_vlsu_stall_pipe0\000microarch\000 \000event=0x85\000\00000\000\000"
/* offset=20913 */ "vpu_hazard_stall_pipe1\000microarch\000 \000event=0x86\000\00000\000\000"
/* offset=20964 */ "vpu_uncommit_stall_pipe1\000microarch\000 \000event=0x87\000\00000\000\000"
/* offset=21017 */ "vpu_vlsu_stall_pipe1\000microarch\000 \000event=0x88\000\00000\000\000"
/* offset=21066 */ "vpu_div_busy\000microarch\000 \000event=0x89\000\00000\000\000"
/* offset=21107 */ "bju_cp0_stall\000microarch\000 \000event=0x8a\000\00000\000\000"
/* offset=21149 */ "bju_ibuf_stall\000microarch\000 \000event=0x8b\000\00000\000\000"
/* offset=21192 */ "bju_wb_stall\000microarch\000 \000event=0x8c\000\00000\000\000"
/* offset=21233 */ "bju_pipedown\000microarch\000 \000event=0x8d\000\00000\000\000"
/* offset=21274 */ "vidu_vec0_stall\000microarch\000 \000event=0x8e\000\00000\000\000"
/* offset=21318 */ "vidu_vec1_stall\000microarch\000 \000event=0x8f\000\00000\000\000"
/* offset=21362 */ "vidu_vec0_depend_stall\000microarch\000 \000event=0x90\000\00000\000\000"
/* offset=21413 */ "vidu_vec0_struct_hazard_stall\000microarch\000 \000event=0x91\000\00000\000\000"
/* offset=21471 */ "vidu_vec1_depend_stall\000microarch\000 \000event=0x92\000\00000\000\000"
/* offset=21522 */ "vidu_vec1_struct_hazard_stall\000microarch\000 \000event=0x93\000\00000\000\000"
/* offset=21580 */ "vidu_total_cycle\000microarch\000 \000event=0x94\000\00000\000\000"
/* offset=21625 */ "vidu_vec0_cycle\000microarch\000 \000event=0x95\000\00000\000\000"
/* offset=21669 */ "vidu_vec1_cycle\000microarch\000 \000event=0x96\000\00000\000\000"
/* offset=21713 */ "vector_micro_op\000microarch\000 \000event=0x97\000\00000\000\000"
/* offset=21757 */ "rtu_flush_cycle\000microarch\000 \000event=0x98\000\00000\000\000"
/* offset=21801 */ "rtu_only_iu_not_no_op\000microarch\000 \000event=0x99\000\00000\000\000"
/* offset=21851 */ "rtu_only_bju_not_no_op\000microarch\000 \000event=0x9a\000\00000\000\000"
/* offset=21902 */ "rtu_only_cp0_not_no_op\000microarch\000 \000event=0x9b\000\00000\000\000"
/* offset=21953 */ "rtu_only_lsu_not_no_op\000microarch\000 \000event=0x9c\000\00000\000\000"
/* offset=22004 */ "rtu_only_vfpu_not_no_op\000microarch\000 \000event=0x9d\000\00000\000\000"
/* offset=22056 */ "rtu_iu_not_no_op\000microarch\000 \000event=0x9e\000\00000\000\000"
/* offset=22101 */ "rtu_bju_not_no_op\000microarch\000 \000event=0x9f\000\00000\000\000"
/* offset=22147 */ "rtu_cp0_not_no_op\000microarch\000 \000event=0xa0\000\00000\000\000"
/* offset=22193 */ "rtu_lsu_not_no_op\000microarch\000 \000event=0xa1\000\00000\000\000"
/* offset=22239 */ "rtu_vfpu_not_no_op\000microarch\000 \000event=0xa2\000\00000\000\000"
/* offset=22286 */ "lsu_fence_stall\000microarch\000 \000event=0xa4\000\00000\000\000"
/* offset=22330 */ "lsu_load_waw_stall\000microarch\000 \000event=0xa5\000\00000\000\000"
/* offset=22377 */ "lsu_load_commit_stall\000microarch\000 \000event=0xa6\000\00000\000\000"
/* offset=22427 */ "lsu_load_raw_stall\000microarch\000 \000event=0xa7\000\00000\000\000"
/* offset=22474 */ "lsu_store_commit_stall\000microarch\000 \000event=0xa8\000\00000\000\000"
/* offset=22525 */ "vidu_rf_no_pipedown\000microarch\000 \000event=0xa9\000\00000\000\000"
/* offset=22573 */ "access_mmu_stlb\000common\000access MMU STLB\000event=1\000\00000\000\000"
/* offset=22625 */ "miss_mmu_stlb\000common\000miss MMU STLB\000event=2\000\00000\000\000"
/* offset=22673 */ "access_mmu_pte_c\000common\000access MMU PTE-Cache\000event=3\000\00000\000\000"
/* offset=22731 */ "miss_mmu_pte_c\000common\000miss MMU PTE-Cache\000event=4\000\00000\000\000"
/* offset=22785 */ "rob_flush\000common\000ROB flush (all kinds of exceptions)\000event=5\000\00000\000\000"
/* offset=22851 */ "btb_prediction_miss\000common\000BTB prediction miss\000event=6\000\00000\000\000"
/* offset=22911 */ "itlb_miss\000common\000ITLB miss\000event=7\000\00000\000\000"
/* offset=22951 */ "sync_del_fetch_g\000common\000SYNC delivery a fetch-group\000event=8\000\00000\000\000"
/* offset=23016 */ "icache_miss\000common\000ICache miss\000event=9\000\00000\000\000"
/* offset=23060 */ "bpu_br_retire\000common\000condition branch instruction retire\000event=0xa\000\00000\000\000"
/* offset=23132 */ "bpu_br_miss\000common\000condition branch instruction miss\000event=0xb\000\00000\000\000"
/* offset=23200 */ "ret_ins_retire\000common\000return instruction retire\000event=0xc\000\00000\000\000"
/* offset=23263 */ "ret_ins_miss\000common\000return instruction miss\000event=0xd\000\00000\000\000"
/* offset=23322 */ "indirect_jr_miss\000common\000indirect JR instruction miss (inlcude without target)\000event=0xe\000\00000\000\000"
/* offset=23415 */ "ibuf_val_id_nordy\000common\000IBUF valid while ID not ready\000event=0xf\000\00000\000\000"
/* offset=23485 */ "ibuf_noval_id_rdy\000common\000IBUF not valid while ID ready\000event=0x10\000\00000\000\000"
/* offset=23556 */ "ren_int_phy_reg_nordy\000common\000REN integer physical register file is not ready\000event=0x11\000\00000\000\000"
/* offset=23649 */ "ren_fp_phy_reg_nordy\000common\000REN floating point physical register file is not ready\000event=0x12\000\00000\000\000"
/* offset=23748 */ "ren_cp_nordy\000common\000REN checkpoint is not ready\000event=0x13\000\00000\000\000"
/* offset=23812 */ "dec_val_rob_nordy\000common\000DEC is valid and ROB is not ready\000event=0x14\000\00000\000\000"
/* offset=23887 */ "ood_flush_ls_dep\000common\000out of order flush due to load/store dependency\000event=0x15\000\00000\000\000"
/* offset=23975 */ "bru_ret_ijr_ins\000common\000BRU retire an IJR instruction\000event=0x16\000\00000\000\000"
/* offset=24044 */ "access_dtlb\000common\000access DTLB\000event=0x17\000\00000\000\000"
/* offset=24091 */ "miss_dtlb\000common\000miss DTLB\000event=0x18\000\00000\000\000"
/* offset=24134 */ "load_ins_dcache\000common\000load instruction access DCache\000event=0x19\000\00000\000\000"
/* offset=24204 */ "load_ins_miss_dcache\000common\000load instruction miss DCache\000event=0x1a\000\00000\000\000"
/* offset=24277 */ "store_ins_dcache\000common\000store/amo instruction access DCache\000event=0x1b\000\00000\000\000"
/* offset=24353 */ "store_ins_miss_dcache\000common\000store/amo instruction miss DCache\000event=0x1c\000\00000\000\000"
/* offset=24432 */ "load_scache\000common\000load access SCache\000event=0x1d\000\00000\000\000"
/* offset=24486 */ "store_scache\000common\000store access SCache\000event=0x1e\000\00000\000\000"
/* offset=24542 */ "load_miss_scache\000common\000load miss SCache\000event=0x1f\000\00000\000\000"
/* offset=24599 */ "store_miss_scache\000common\000store miss SCache\000event=0x20\000\00000\000\000"
/* offset=24658 */ "l2c_pf_req\000common\000L2C data-prefetcher request\000event=0x21\000\00000\000\000"
/* offset=24720 */ "l2c_pf_hit\000common\000L2C data-prefetcher hit\000event=0x22\000\00000\000\000"
/* offset=24778 */ "l1_icache_access\000cache\000L1 instruction cache access\000event=1\000\00000\000\000"
/* offset=24842 */ "l1_icache_miss\000cache\000L1 instruction cache miss\000event=2\000\00000\000\000"
/* offset=24902 */ "itlb_miss\000cache\000I-UTLB miss\000event=3\000\00000\000\000"
/* offset=24943 */ "dtlb_miss\000cache\000D-UTLB miss\000event=4\000\00000\000\000"
/* offset=24984 */ "jtlb_miss\000cache\000JTLB miss\000event=5\000\00000\000\000"
/* offset=25023 */ "l1_dcache_read_access\000cache\000L1 data cache read access\000event=0xc\000\00000\000\000"
/* offset=25092 */ "l1_dcache_read_miss\000cache\000L1 data cache read miss\000event=0xd\000\00000\000\000"
/* offset=25157 */ "l1_dcache_write_access\000cache\000L1 data cache write access\000event=0xe\000\00000\000\000"
/* offset=25228 */ "l1_dcache_write_miss\000cache\000L1 data cache write miss\000event=0xf\000\00000\000\000"
/* offset=25295 */ "ll_cache_read_access\000cache\000LL Cache read access\000event=0x10\000\00000\000\000"
/* offset=25359 */ "ll_cache_read_miss\000cache\000LL Cache read miss\000event=0x11\000\00000\000\000"
/* offset=25419 */ "ll_cache_write_access\000cache\000LL Cache write access\000event=0x12\000\00000\000\000"
/* offset=25485 */ "ll_cache_write_miss\000cache\000LL Cache write miss\000event=0x13\000\00000\000\000"
/* offset=25547 */ "inst_branch_mispredict\000instruction\000Mispredicted branch instructions\000event=6\000\00000\000\000"
/* offset=25628 */ "inst_branch\000instruction\000Retired branch instructions\000event=7\000\00000\000\000"
/* offset=25693 */ "inst_jmp_mispredict\000instruction\000Indirect branch mispredict\000event=8\000\00000\000\000"
/* offset=25765 */ "inst_jmp\000instruction\000Retired jmp instructions\000event=9\000\00000\000\000"
/* offset=25824 */ "inst_store\000instruction\000Retired store instructions\000event=0xb\000\00000\000\000"
/* offset=25889 */ "inst_alu\000instruction\000Retired ALU instructions\000event=0x1d\000\00000\000\000"
/* offset=25951 */ "inst_ldst\000instruction\000Retired Load/Store instructions\000event=0x1e\000\00000\000\000"
/* offset=26021 */ "inst_vector\000instruction\000Retired Vector instructions\000event=0x1f\000\00000\000\000"
/* offset=26089 */ "inst_csr\000instruction\000Retired CSR instructions\000event=0x20\000\00000\000\000"
/* offset=26151 */ "inst_sync\000instruction\000Retired sync instructions (AMO/LR/SC instructions)\000event=0x21\000\00000\000\000"
/* offset=26240 */ "inst_unaligned_access\000instruction\000Retired Store/Load instructions with unaligned memory access\000event=0x22\000\00000\000\000"
/* offset=26351 */ "inst_ecall\000instruction\000Retired ecall instructions\000event=0x25\000\00000\000\000"
/* offset=26417 */ "inst_long_jp\000instruction\000Retired long jump instructions\000event=0x26\000\00000\000\000"
/* offset=26489 */ "inst_fp\000instruction\000Retired FPU instructions\000event=0x2a\000\00000\000\000"
/* offset=26550 */ "lsu_spec_fail\000microarch\000LSU speculation fail\000event=0xa\000\00000\000\000"
/* offset=26610 */ "idu_rf_pipe_fail\000microarch\000Instruction decode unit launch pipeline failed in RF state\000event=0x14\000\00000\000\000"
/* offset=26712 */ "idu_rf_reg_fail\000microarch\000Instruction decode unit launch register file fail in RF state\000event=0x15\000\00000\000\000"
/* offset=26816 */ "idu_rf_instruction\000microarch\000retired instruction count of Instruction decode unit in RF (Register File) stage\000event=0x16\000\00000\000\000"
/* offset=26942 */ "lsu_4k_stall\000microarch\000LSU stall times for long distance data access (Over 4K)\000event=0x17\000\00000\000This stall occurs when translate virtual address with page offset over 4k\000"
/* offset=27110 */ "lsu_other_stall\000microarch\000LSU stall times for other reasons (except the 4k stall)\000event=0x18\000\00000\000\000"
/* offset=27208 */ "lsu_sq_other_dis\000microarch\000LSU store queue discard others\000event=0x19\000\00000\000\000"
/* offset=27282 */ "lsu_sq_data_discard\000microarch\000LSU store queue discard data (uops)\000event=0x1a\000\00000\000\000"
/* offset=27364 */ "branch_direction_misprediction\000microarch\000Branch misprediction in BTB\000event=0x1b\000\00000\000\000"
/* offset=27449 */ "branch_direction_prediction\000microarch\000All branch prediction in BTB\000event=0x1c\000\00000\000This event including both successful prediction and failed prediction in BTB\000"
/* offset=27608 */ "interrupt_ack_count\000microarch\000acknowledged interrupt count\000event=0x23\000\00000\000\000"
/* offset=27683 */ "interrupt_off_cycle\000microarch\000PLIC arbitration time when the interrupt is not responded\000event=0x24\000\00000\000The arbitration time is recorded while meeting any of the following:\n- CPU is M-mode and MIE == 0\n- CPU is S-mode and delegation and SIE == 0\n\000"
/* offset=27929 */ "ifu_stalled_cycle\000microarch\000Number of stall cycles of the instruction fetch unit (IFU)\000event=0x27\000\00000\000\000"
/* offset=28032 */ "idu_stalled_cycle\000microarch\000hpcp_backend_stall Number of stall cycles of the instruction decoding unit (IDU) and next-level pipeline unit\000event=0x28\000\00000\000\000"
/* offset=28186 */ "sync_stall\000microarch\000Sync instruction stall cycle fence/fence.i/sync/sfence\000event=0x29\000\00000\000\000"
/* offset=28278 */ "bp_l1_btb_correct\000branch\000L1 BTB Correction\000event=0x8a\000\00000\000\000"
/* offset=28337 */ "bp_l2_btb_correct\000branch\000L2 BTB Correction\000event=0x8b\000\00000\000\000"
/* offset=28396 */ "l3_cache_rd\000cache\000L3 cache access, read\000event=0x40\000\00000\000Attributable Level 3 cache access, read\000"
/* offset=28491 */ "segment_reg_loads.any\000other\000Number of segment register loads\000event=6,period=200000,umask=0x80\000\00000\000\000"
/* offset=28590 */ "dispatch_blocked.any\000other\000Memory cluster signals to block micro-op dispatch for any reason\000event=9,period=200000,umask=0x20\000\00000\000\000"
/* offset=28720 */ "eist_trans\000other\000Number of Enhanced Intel SpeedStep(R) Technology (EIST) transitions\000event=0x3a,period=200000\000\00000\000\000"
/* offset=28835 */ "hisi_sccl,ddrc\000"
/* offset=28850 */ "uncore_hisi_ddrc.flux_wcmd\000uncore\000DDRC write commands\000event=2\000\00000\000DDRC write commands\000"
/* offset=28936 */ "uncore_cbox\000"
/* offset=28948 */ "unc_cbo_xsnp_response.miss_eviction\000uncore\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000event=0x22,umask=0x81\000\00000\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000"
/* offset=29179 */ "event-hyphen\000uncore\000UNC_CBO_HYPHEN\000event=0xe0\000\00000\000UNC_CBO_HYPHEN\000"
/* offset=29244 */ "event-two-hyph\000uncore\000UNC_CBO_TWO_HYPH\000event=0xc0\000\00000\000UNC_CBO_TWO_HYPH\000"
/* offset=29315 */ "hisi_sccl,l3c\000"
/* offset=29329 */ "uncore_hisi_l3c.rd_hit_cpipe\000uncore\000Total read hits\000event=7\000\00000\000Total read hits\000"
/* offset=29409 */ "uncore_imc_free_running\000"
/* offset=29433 */ "uncore_imc_free_running.cache_miss\000uncore\000Total cache misses\000event=0x12\000\00000\000Total cache misses\000"
/* offset=29528 */ "uncore_imc\000"
/* offset=29539 */ "uncore_imc.cache_hits\000uncore\000Total cache hits\000event=0x34\000\00000\000Total cache hits\000"
/* offset=29617 */ "uncore_sys_ddr_pmu\000"
/* offset=29636 */ "sys_ddr_pmu.write_cycles\000uncore\000ddr write-cycles event\000event=0x2b\000v8\00000\000\000"
/* offset=29709 */ "uncore_sys_ccn_pmu\000"
/* offset=29728 */ "sys_ccn_pmu.read_cycles\000uncore\000ccn read-cycles event\000config=0x2c\0000x01\00000\000\000"
/* offset=29802 */ "uncore_sys_cmn_pmu\000"
/* offset=29821 */ "sys_cmn_pmu.hnf_cache_miss\000uncore\000Counts total cache misses in first lookup result (high priority)\000eventid=1,type=5\000(434|436|43c|43a).*\00000\000\000"
/* offset=29961 */ "CPI\000\0001 / IPC\000\000\000\000\000\000\000\00000"
/* offset=29983 */ "IPC\000group1\000inst_retired.any / cpu_clk_unhalted.thread\000\000\000\000\000\000\000\00000"
/* offset=30046 */ "Frontend_Bound_SMT\000\000idq_uops_not_delivered.core / (4 * (cpu_clk_unhalted.thread / 2 * (1 + cpu_clk_unhalted.one_thread_active / cpu_clk_unhalted.ref_xclk)))\000\000\000\000\000\000\000\00000"
/* offset=30212 */ "dcache_miss_cpi\000\000l1d\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000"
/* offset=30276 */ "icache_miss_cycles\000\000l1i\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000"
/* offset=30343 */ "cache_miss_cycles\000group1\000dcache_miss_cpi + icache_miss_cycles\000\000\000\000\000\000\000\00000"
/* offset=30414 */ "DCache_L2_All_Hits\000\000l2_rqsts.demand_data_rd_hit + l2_rqsts.pf_hit + l2_rqsts.rfo_hit\000\000\000\000\000\000\000\00000"
/* offset=30508 */ "DCache_L2_All_Miss\000\000max(l2_rqsts.all_demand_data_rd - l2_rqsts.demand_data_rd_hit, 0) + l2_rqsts.pf_miss + l2_rqsts.rfo_miss\000\000\000\000\000\000\000\00000"
/* offset=30642 */ "DCache_L2_All\000\000DCache_L2_All_Hits + DCache_L2_All_Miss\000\000\000\000\000\000\000\00000"
/* offset=30706 */ "DCache_L2_Hits\000\000d_ratio(DCache_L2_All_Hits, DCache_L2_All)\000\000\000\000\000\000\000\00000"
/* offset=30774 */ "DCache_L2_Misses\000\000d_ratio(DCache_L2_All_Miss, DCache_L2_All)\000\000\000\000\000\000\000\00000"
/* offset=30844 */ "M1\000\000ipc + M2\000\000\000\000\000\000\000\00000"
/* offset=30866 */ "M2\000\000ipc + M1\000\000\000\000\000\000\000\00000"
/* offset=30888 */ "M3\000\0001 / M3\000\000\000\000\000\000\000\00000"
/* offset=30908 */ "L1D_Cache_Fill_BW\000\00064 * l1d.replacement / 1e9 / duration_time\000\000\000\000\000\000\000\00000"
;

static const struct compact_pmu_event pmu_events__common_tool[] = {
{ 5 }, /* duration_time\000tool\000Wall clock interval time in nanoseconds\000config=1\000\00000\000\000 */
{ 210 }, /* has_pmem\000tool\0001 if persistent memory installed otherwise 0\000config=4\000\00000\000\000 */
{ 283 }, /* num_cores\000tool\000Number of cores. A core consists of 1 or more thread, with each thread being associated with a logical Linux CPU\000config=5\000\00000\000\000 */
{ 425 }, /* num_cpus\000tool\000Number of logical Linux CPUs. There may be multiple such CPUs on a core\000config=6\000\00000\000\000 */
{ 525 }, /* num_cpus_online\000tool\000Number of online logical Linux CPUs. There may be multiple such CPUs on a core\000config=7\000\00000\000\000 */
{ 639 }, /* num_dies\000tool\000Number of dies. Each die has 1 or more cores\000config=8\000\00000\000\000 */
{ 712 }, /* num_packages\000tool\000Number of packages. Each package has 1 or more die\000config=9\000\00000\000\000 */
{ 795 }, /* slots\000tool\000Number of functional units that in parallel can execute parts of an instruction\000config=0xa\000\00000\000\000 */
{ 902 }, /* smt_on\000tool\0001 if simultaneous multithreading (aka hyperthreading) is enable otherwise 0\000config=0xb\000\00000\000\000 */
{ 145 }, /* system_time\000tool\000System/kernel time in nanoseconds\000config=3\000\00000\000\000 */
{ 1006 }, /* system_tsc_freq\000tool\000The amount a Time Stamp Counter (TSC) increases per second\000config=0xc\000\00000\000\000 */
{ 78 }, /* user_time\000tool\000User (non-kernel) time in nanoseconds\000config=2\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__common[] = {
{
     .entries = pmu_events__common_tool,
     .num_entries = ARRAY_SIZE(pmu_events__common_tool),
     .pmu_name = { 0 /* tool\000 */ },
},
};

static const struct compact_pmu_event pmu_events__andes_ax45_default_core[] = {
{ 4531 }, /* atomic_inst\000instructions\000Atomic instruction count\000event=0x50\000\00000\000\000 */
{ 4746 }, /* condition_br\000instructions\000Conditional branch instruction count\000event=0x80\000\00000\000\000 */
{ 5101 }, /* control_trans_inst\000instructions\000Control transfer instruction count\000event=0xd0\000\00000\000\000 */
{ 4262 }, /* cycle_count\000instructions\000Cycle count\000event=0x10\000\00000\000\000 */
{ 6916 }, /* cycle_wait_dcache_fill\000microarch\000Cycles waiting for DCACHE fill data\000event=0xc1\000\00000\000\000 */
{ 6831 }, /* cycle_wait_icache_fill\000microarch\000Cycles waiting for ICACHE fill data\000event=0xb1\000\00000\000\000 */
{ 7610 }, /* cycle_wait_itlb_fill\000microarch\000Cycles waiting for Main ITLB fill data\000event=0x151\000\00000\000\000 */
{ 7173 }, /* cycle_wait_uncached_ifetch\000microarch\000Cycles waiting for uncached ifetch data from bus\000event=0xf1\000\00000\000\000 */
{ 7275 }, /* cycle_wait_uncached_load\000microarch\000Cycles waiting for uncached load data from bus\000event=0x101\000\00000\000\000 */
{ 6443 }, /* dcache_access\000memory\000DCACHE access\000event=0x41\000\00000\000\000 */
{ 6541 }, /* dcache_load_access\000memory\000DCACHE load access\000event=0x61\000\00000\000\000 */
{ 6602 }, /* dcache_load_miss\000memory\000DCACHE load miss\000event=0x71\000\00000\000\000 */
{ 6494 }, /* dcache_miss\000memory\000DCACHE miss\000event=0x51\000\00000\000\000 */
{ 6659 }, /* dcache_store_access\000memory\000DCACHE store access\000event=0x81\000\00000\000\000 */
{ 6722 }, /* dcache_store_miss\000memory\000DCACHE store miss\000event=0x91\000\00000\000\000 */
{ 6781 }, /* dcache_wb\000memory\000DCACHE writeback\000event=0xa1\000\00000\000\000 */
{ 6300 }, /* dlm_access\000memory\000DLM access\000event=0x11\000\00000\000\000 */
{ 5184 }, /* ex9_inst\000instructions\000EXEC.IT instruction count\000event=0xe0\000\00000\000\000 */
{ 5593 }, /* float_add_sub_inst\000instructions\000Floating-point addition/subtraction instruction count\000event=0x130\000\00000\000\000 */
{ 5895 }, /* float_div_sqrt_inst\000instructions\000Floating-point division or square-root instruction count\000event=0x160\000\00000\000\000 */
{ 5789 }, /* float_fused_muladd_inst\000instructions\000Floating-point fused multiply-add instruction count\000event=0x150\000\00000\000\000 */
{ 5423 }, /* float_load_inst\000instructions\000Floating-point load instruction count\000event=0x110\000\00000\000\000 */
{ 5696 }, /* float_mul_inst\000instructions\000Floating-point multiplication instruction count\000event=0x140\000\00000\000\000 */
{ 5507 }, /* float_store_inst\000instructions\000Floating-point store instruction count\000event=0x120\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 6345 }, /* icache_access\000memory\000ICACHE access\000event=0x21\000\00000\000\000 */
{ 6396 }, /* icache_miss\000memory\000ICACHE miss\000event=0x31\000\00000\000\000 */
{ 6258 }, /* ilm_access\000memory\000ILM access\000event=1\000\00000\000\000 */
{ 4315 }, /* inst_count\000instructions\000Retired instruction count\000event=0x20\000\00000\000\000 */
{ 4660 }, /* int_compute_inst\000instructions\000Integer computational instruction count\000event=0x70\000\00000\000\000 */
{ 5331 }, /* int_div_rem_inst\000instructions\000Integer division/remainder instruction count\000event=0x100\000\00000\000\000 */
{ 4381 }, /* int_load_inst\000instructions\000Integer load instruction count\000event=0x30\000\00000\000\000 */
{ 6088 }, /* int_mul_add_sub_inst\000instructions\000Integer multiplication and add/sub instruction count\000event=0x180\000\00000\000\000 */
{ 5248 }, /* int_mul_inst\000instructions\000Integer multiplication instruction count\000event=0xf0\000\00000\000\000 */
{ 4455 }, /* int_store_inst\000instructions\000Integer store instruction count\000event=0x40\000\00000\000\000 */
{ 4916 }, /* jal_inst\000instructions\000JAL instruction count\000event=0xa0\000\00000\000\000 */
{ 4976 }, /* jalr_inst\000instructions\000JALR instruction count\000event=0xb0\000\00000\000\000 */
{ 7492 }, /* main_dtlb_access\000microarch\000Main DTLB access\000event=0x131\000\00000\000\000 */
{ 7553 }, /* main_dtlb_miss\000microarch\000Main DTLB miss\000event=0x141\000\00000\000\000 */
{ 7374 }, /* main_itlb_access\000microarch\000Main ITLB access\000event=0x111\000\00000\000\000 */
{ 7435 }, /* main_itlb_miss\000microarch\000Main ITLB miss\000event=0x121\000\00000\000\000 */
{ 7798 }, /* mispredict_condition_br\000microarch\000Misprediction of conditional branches\000event=2\000\00000\000\000 */
{ 7883 }, /* mispredict_take_condition_br\000microarch\000Misprediction of taken conditional branches\000event=0x12\000\00000\000\000 */
{ 7982 }, /* mispredict_target_ret_inst\000microarch\000Misprediction of targets of Return instructions\000event=0x22\000\00000\000\000 */
{ 6002 }, /* other_float_inst\000instructions\000Other floating-point instruction count\000event=0x170\000\00000\000\000 */
{ 7697 }, /* pipe_stall_cycle_dtlb_miss\000microarch\000Pipeline stall cycles caused by Main DTLB miss\000event=0x161\000\00000\000\000 */
{ 5038 }, /* ret_inst\000instructions\000Return instruction count\000event=0xc0\000\00000\000\000 */
{ 6192 }, /* retired_ops\000instructions\000Retired operation count\000event=0x190\000\00000\000\000 */
{ 4597 }, /* sys_inst\000instructions\000System instruction count\000event=0x60\000\00000\000\000 */
{ 4825 }, /* taken_condition_br\000instructions\000Taken conditional branch instruction count\000event=0x90\000\00000\000\000 */
{ 7001 }, /* uncached_ifetch_from_bus\000microarch\000Uncached ifetch data access from bus\000event=0xd1\000\00000\000\000 */
{ 7089 }, /* uncached_load_from_bus\000microarch\000Uncached load data access from bus\000event=0xe1\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__andes_ax45[] = {
{
     .entries = pmu_events__andes_ax45_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__andes_ax45_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__sifive_bullet_default_core[] = {
{ 10413 }, /* addressgen_interlock\000microarch\000Counts cycles with an address-generation interlock\000event=0x101\000\00000\000\000 */
{ 8336 }, /* atomic_memory_retired\000instruction\000Counts atomic memory instructions retired\000event=0x800\000\00000\000\000 */
{ 10911 }, /* branch_direction_misprediction\000microarch\000Counts mispredictions of conditional branch direction (taken/not taken)\000event=0x2001\000\00000\000\000 */
{ 11042 }, /* branch_target_misprediction\000microarch\000Counts mispredictions of the target PC of control-flow instructions\000event=0x4001\000\00000\000\000 */
{ 8648 }, /* conditional_branch_retired\000instruction\000Counts conditional branch instructions retired\000event=0x4000\000\00000\000\000 */
{ 10605 }, /* csr_interlock\000microarch\000Counts cycles with a CSR interlock\000event=0x401\000\00000\000\000 */
{ 10807 }, /* dcache_blocked\000microarch\000Counts cycles in which the data cache blocked an instruction\000event=0x1001\000\00000\000\000 */
{ 9950 }, /* dcache_miss\000memory\000Counts data cache misses\000event=0x202\000\00000\000\000 */
{ 10011 }, /* dcache_release\000memory\000Counts writeback requests from the data cache\000event=0x402\000\00000\000\000 */
{ 10211 }, /* dtlb_miss\000memory\000Counts Data TLB misses caused by data address translation requests\000event=0x1002\000\00000\000\000 */
{ 8083 }, /* exception_taken\000instruction\000Counts exceptions taken\000event=0x100\000\00000\000\000 */
{ 9360 }, /* fp_add_retired\000instruction\000Counts floating-point add instructions retired\000event=0x200000\000\00000\000\000 */
{ 9665 }, /* fp_div_sqrt_retired\000instruction\000Counts floating point divide or square root instructions retired\000event=0x1000000\000\00000\000\000 */
{ 11461 }, /* fp_interlock\000microarch\000Counts cycles with a floating-point interlock\000event=0x40001\000\00000\000\000 */
{ 9167 }, /* fp_load_retired\000instruction\000Counts floating-point load instructions retired\000event=0x80000\000\00000\000\000 */
{ 9454 }, /* fp_mul_retired\000instruction\000Counts floating-point multiply instructions retired\000event=0x400000\000\00000\000\000 */
{ 9553 }, /* fp_muladd_retired\000instruction\000Counts floating-point fused multiply-add instructions retired\000event=0x800000\000\00000\000\000 */
{ 9262 }, /* fp_store_retired\000instruction\000Counts floating-point store instructions retired\000event=0x100000\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 10681 }, /* icache_blocked\000microarch\000Counts cycles in which the instruction cache was not able to provide an instruction\000event=0x801\000\00000\000\000 */
{ 9882 }, /* icache_miss\000memory\000Counts instruction cache misses\000event=0x102\000\00000\000\000 */
{ 8544 }, /* integer_arithmetic_retired\000instruction\000Counts integer arithmetic instructions retired\000event=0x2000\000\00000\000\000 */
{ 9066 }, /* integer_division_retired\000instruction\000Counts integer division instructions retired\000event=0x40000\000\00000\000\000 */
{ 8152 }, /* integer_load_retired\000instruction\000Counts integer load instructions retired\000event=0x200\000\00000\000\000 */
{ 11356 }, /* integer_mul_div_interlock\000microarch\000Counts cycles with a multiply or divide interlock\000event=0x20001\000\00000\000\000 */
{ 8953 }, /* integer_multiplication_retired\000instruction\000Counts integer multiplication instructions retired\000event=0x20000\000\00000\000\000 */
{ 8243 }, /* integer_store_retired\000instruction\000Counts integer store instructions retired\000event=0x400\000\00000\000\000 */
{ 10096 }, /* itlb_miss\000memory\000Counts Instruction TLB misses caused by instruction address translation requests\000event=0x802\000\00000\000\000 */
{ 8752 }, /* jal_instruction_retired\000instruction\000Counts jump-and-link instructions retired\000event=0x8000\000\00000\000\000 */
{ 8848 }, /* jalr_instruction_retired\000instruction\000Counts indirect jump instructions (JALR) retired\000event=0x10000\000\00000\000\000 */
{ 10512 }, /* longlatency_interlock\000microarch\000Counts cycles with a long-latency interlock\000event=0x201\000\00000\000\000 */
{ 9783 }, /* other_fp_retired\000instruction\000Counts other floating-point instructions retired\000event=0x2000000\000\00000\000\000 */
{ 11166 }, /* pipeline_flush\000microarch\000Counts flushes of the core pipeline. Common causes include fence.i and CSR accesses\000event=0x8001\000\00000\000\000 */
{ 11293 }, /* replay\000microarch\000Counts instruction replays\000event=0x10001\000\00000\000\000 */
{ 8429 }, /* system_instruction_retired\000instruction\000Counts system instructions retired (CSR, WFI, MRET, etc.)\000event=0x1000\000\00000\000\000 */
{ 10313 }, /* utlb_miss\000memory\000Counts Unified TLB misses caused by address translation requests\000event=0x2002\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__sifive_bullet[] = {
{
     .entries = pmu_events__sifive_bullet_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__sifive_bullet_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__sifive_bullet_07_default_core[] = {
{ 10413 }, /* addressgen_interlock\000microarch\000Counts cycles with an address-generation interlock\000event=0x101\000\00000\000\000 */
{ 8336 }, /* atomic_memory_retired\000instruction\000Counts atomic memory instructions retired\000event=0x800\000\00000\000\000 */
{ 10911 }, /* branch_direction_misprediction\000microarch\000Counts mispredictions of conditional branch direction (taken/not taken)\000event=0x2001\000\00000\000\000 */
{ 11042 }, /* branch_target_misprediction\000microarch\000Counts mispredictions of the target PC of control-flow instructions\000event=0x4001\000\00000\000\000 */
{ 8648 }, /* conditional_branch_retired\000instruction\000Counts conditional branch instructions retired\000event=0x4000\000\00000\000\000 */
{ 11549 }, /* core_clock_cycles\000cycle and instruction count\000Counts core clock cycles\000event=0x165\000\00000\000\000 */
{ 10605 }, /* csr_interlock\000microarch\000Counts cycles with a CSR interlock\000event=0x401\000\00000\000\000 */
{ 10807 }, /* dcache_blocked\000microarch\000Counts cycles in which the data cache blocked an instruction\000event=0x1001\000\00000\000\000 */
{ 9950 }, /* dcache_miss\000memory\000Counts data cache misses\000event=0x202\000\00000\000\000 */
{ 10011 }, /* dcache_release\000memory\000Counts writeback requests from the data cache\000event=0x402\000\00000\000\000 */
{ 10211 }, /* dtlb_miss\000memory\000Counts Data TLB misses caused by data address translation requests\000event=0x1002\000\00000\000\000 */
{ 8083 }, /* exception_taken\000instruction\000Counts exceptions taken\000event=0x100\000\00000\000\000 */
{ 9360 }, /* fp_add_retired\000instruction\000Counts floating-point add instructions retired\000event=0x200000\000\00000\000\000 */
{ 9665 }, /* fp_div_sqrt_retired\000instruction\000Counts floating point divide or square root instructions retired\000event=0x1000000\000\00000\000\000 */
{ 11461 }, /* fp_interlock\000microarch\000Counts cycles with a floating-point interlock\000event=0x40001\000\00000\000\000 */
{ 9167 }, /* fp_load_retired\000instruction\000Counts floating-point load instructions retired\000event=0x80000\000\00000\000\000 */
{ 9454 }, /* fp_mul_retired\000instruction\000Counts floating-point multiply instructions retired\000event=0x400000\000\00000\000\000 */
{ 9553 }, /* fp_muladd_retired\000instruction\000Counts floating-point fused multiply-add instructions retired\000event=0x800000\000\00000\000\000 */
{ 9262 }, /* fp_store_retired\000instruction\000Counts floating-point store instructions retired\000event=0x100000\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 10681 }, /* icache_blocked\000microarch\000Counts cycles in which the instruction cache was not able to provide an instruction\000event=0x801\000\00000\000\000 */
{ 9882 }, /* icache_miss\000memory\000Counts instruction cache misses\000event=0x102\000\00000\000\000 */
{ 11637 }, /* instructions_retired\000cycle and instruction count\000Counts instructions retired\000event=0x265\000\00000\000\000 */
{ 8544 }, /* integer_arithmetic_retired\000instruction\000Counts integer arithmetic instructions retired\000event=0x2000\000\00000\000\000 */
{ 9066 }, /* integer_division_retired\000instruction\000Counts integer division instructions retired\000event=0x40000\000\00000\000\000 */
{ 8152 }, /* integer_load_retired\000instruction\000Counts integer load instructions retired\000event=0x200\000\00000\000\000 */
{ 11356 }, /* integer_mul_div_interlock\000microarch\000Counts cycles with a multiply or divide interlock\000event=0x20001\000\00000\000\000 */
{ 8953 }, /* integer_multiplication_retired\000instruction\000Counts integer multiplication instructions retired\000event=0x20000\000\00000\000\000 */
{ 8243 }, /* integer_store_retired\000instruction\000Counts integer store instructions retired\000event=0x400\000\00000\000\000 */
{ 10096 }, /* itlb_miss\000memory\000Counts Instruction TLB misses caused by instruction address translation requests\000event=0x802\000\00000\000\000 */
{ 8752 }, /* jal_instruction_retired\000instruction\000Counts jump-and-link instructions retired\000event=0x8000\000\00000\000\000 */
{ 8848 }, /* jalr_instruction_retired\000instruction\000Counts indirect jump instructions (JALR) retired\000event=0x10000\000\00000\000\000 */
{ 10512 }, /* longlatency_interlock\000microarch\000Counts cycles with a long-latency interlock\000event=0x201\000\00000\000\000 */
{ 9783 }, /* other_fp_retired\000instruction\000Counts other floating-point instructions retired\000event=0x2000000\000\00000\000\000 */
{ 11166 }, /* pipeline_flush\000microarch\000Counts flushes of the core pipeline. Common causes include fence.i and CSR accesses\000event=0x8001\000\00000\000\000 */
{ 11293 }, /* replay\000microarch\000Counts instruction replays\000event=0x10001\000\00000\000\000 */
{ 8429 }, /* system_instruction_retired\000instruction\000Counts system instructions retired (CSR, WFI, MRET, etc.)\000event=0x1000\000\00000\000\000 */
{ 11731 }, /* trace_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to backpressure from the Trace Encoder\000event=0x80001\000\00000\000\000 */
{ 10313 }, /* utlb_miss\000memory\000Counts Unified TLB misses caused by address translation requests\000event=0x2002\000\00000\000\000 */
{ 11867 }, /* watchpoint_0\000watchpoint\000Counts occurrences of watchpoint 0 with action=8\000event=0x164\000\00000\000\000 */
{ 11957 }, /* watchpoint_1\000watchpoint\000Counts occurrences of watchpoint 1 with action=8\000event=0x264\000\00000\000\000 */
{ 12047 }, /* watchpoint_2\000watchpoint\000Counts occurrences of watchpoint 2 with action=8\000event=0x464\000\00000\000\000 */
{ 12137 }, /* watchpoint_3\000watchpoint\000Counts occurrences of watchpoint 3 with action=8\000event=0x864\000\00000\000\000 */
{ 12227 }, /* watchpoint_4\000watchpoint\000Counts occurrences of watchpoint 4 with action=8\000event=0x1064\000\00000\000\000 */
{ 12318 }, /* watchpoint_5\000watchpoint\000Counts occurrences of watchpoint 5 with action=8\000event=0x2064\000\00000\000\000 */
{ 12409 }, /* watchpoint_6\000watchpoint\000Counts occurrences of watchpoint 6 with action=8\000event=0x4064\000\00000\000\000 */
{ 12500 }, /* watchpoint_7\000watchpoint\000Counts occurrences of watchpoint 7 with action=8\000event=0x8064\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__sifive_bullet_07[] = {
{
     .entries = pmu_events__sifive_bullet_07_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__sifive_bullet_07_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__sifive_bullet_0d_default_core[] = {
{ 10413 }, /* addressgen_interlock\000microarch\000Counts cycles with an address-generation interlock\000event=0x101\000\00000\000\000 */
{ 8336 }, /* atomic_memory_retired\000instruction\000Counts atomic memory instructions retired\000event=0x800\000\00000\000\000 */
{ 10911 }, /* branch_direction_misprediction\000microarch\000Counts mispredictions of conditional branch direction (taken/not taken)\000event=0x2001\000\00000\000\000 */
{ 11042 }, /* branch_target_misprediction\000microarch\000Counts mispredictions of the target PC of control-flow instructions\000event=0x4001\000\00000\000\000 */
{ 8648 }, /* conditional_branch_retired\000instruction\000Counts conditional branch instructions retired\000event=0x4000\000\00000\000\000 */
{ 11549 }, /* core_clock_cycles\000cycle and instruction count\000Counts core clock cycles\000event=0x165\000\00000\000\000 */
{ 10605 }, /* csr_interlock\000microarch\000Counts cycles with a CSR interlock\000event=0x401\000\00000\000\000 */
{ 10807 }, /* dcache_blocked\000microarch\000Counts cycles in which the data cache blocked an instruction\000event=0x1001\000\00000\000\000 */
{ 9950 }, /* dcache_miss\000memory\000Counts data cache misses\000event=0x202\000\00000\000\000 */
{ 10011 }, /* dcache_release\000memory\000Counts writeback requests from the data cache\000event=0x402\000\00000\000\000 */
{ 10211 }, /* dtlb_miss\000memory\000Counts Data TLB misses caused by data address translation requests\000event=0x1002\000\00000\000\000 */
{ 12706 }, /* dtlb_miss_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to DTLB Miss\000event=0x200001\000\00000\000\000 */
{ 8083 }, /* exception_taken\000instruction\000Counts exceptions taken\000event=0x100\000\00000\000\000 */
{ 9360 }, /* fp_add_retired\000instruction\000Counts floating-point add instructions retired\000event=0x200000\000\00000\000\000 */
{ 9665 }, /* fp_div_sqrt_retired\000instruction\000Counts floating point divide or square root instructions retired\000event=0x1000000\000\00000\000\000 */
{ 11461 }, /* fp_interlock\000microarch\000Counts cycles with a floating-point interlock\000event=0x40001\000\00000\000\000 */
{ 9167 }, /* fp_load_retired\000instruction\000Counts floating-point load instructions retired\000event=0x80000\000\00000\000\000 */
{ 9454 }, /* fp_mul_retired\000instruction\000Counts floating-point multiply instructions retired\000event=0x400000\000\00000\000\000 */
{ 9553 }, /* fp_muladd_retired\000instruction\000Counts floating-point fused multiply-add instructions retired\000event=0x800000\000\00000\000\000 */
{ 9262 }, /* fp_store_retired\000instruction\000Counts floating-point store instructions retired\000event=0x100000\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 10681 }, /* icache_blocked\000microarch\000Counts cycles in which the instruction cache was not able to provide an instruction\000event=0x801\000\00000\000\000 */
{ 9882 }, /* icache_miss\000memory\000Counts instruction cache misses\000event=0x102\000\00000\000\000 */
{ 11637 }, /* instructions_retired\000cycle and instruction count\000Counts instructions retired\000event=0x265\000\00000\000\000 */
{ 8544 }, /* integer_arithmetic_retired\000instruction\000Counts integer arithmetic instructions retired\000event=0x2000\000\00000\000\000 */
{ 9066 }, /* integer_division_retired\000instruction\000Counts integer division instructions retired\000event=0x40000\000\00000\000\000 */
{ 8152 }, /* integer_load_retired\000instruction\000Counts integer load instructions retired\000event=0x200\000\00000\000\000 */
{ 11356 }, /* integer_mul_div_interlock\000microarch\000Counts cycles with a multiply or divide interlock\000event=0x20001\000\00000\000\000 */
{ 8953 }, /* integer_multiplication_retired\000instruction\000Counts integer multiplication instructions retired\000event=0x20000\000\00000\000\000 */
{ 8243 }, /* integer_store_retired\000instruction\000Counts integer store instructions retired\000event=0x400\000\00000\000\000 */
{ 10096 }, /* itlb_miss\000memory\000Counts Instruction TLB misses caused by instruction address translation requests\000event=0x802\000\00000\000\000 */
{ 12591 }, /* itlb_miss_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to ITLB Miss\000event=0x100001\000\00000\000\000 */
{ 8752 }, /* jal_instruction_retired\000instruction\000Counts jump-and-link instructions retired\000event=0x8000\000\00000\000\000 */
{ 8848 }, /* jalr_instruction_retired\000instruction\000Counts indirect jump instructions (JALR) retired\000event=0x10000\000\00000\000\000 */
{ 10512 }, /* longlatency_interlock\000microarch\000Counts cycles with a long-latency interlock\000event=0x201\000\00000\000\000 */
{ 9783 }, /* other_fp_retired\000instruction\000Counts other floating-point instructions retired\000event=0x2000000\000\00000\000\000 */
{ 11166 }, /* pipeline_flush\000microarch\000Counts flushes of the core pipeline. Common causes include fence.i and CSR accesses\000event=0x8001\000\00000\000\000 */
{ 11293 }, /* replay\000microarch\000Counts instruction replays\000event=0x10001\000\00000\000\000 */
{ 8429 }, /* system_instruction_retired\000instruction\000Counts system instructions retired (CSR, WFI, MRET, etc.)\000event=0x1000\000\00000\000\000 */
{ 11731 }, /* trace_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to backpressure from the Trace Encoder\000event=0x80001\000\00000\000\000 */
{ 10313 }, /* utlb_miss\000memory\000Counts Unified TLB misses caused by address translation requests\000event=0x2002\000\00000\000\000 */
{ 11867 }, /* watchpoint_0\000watchpoint\000Counts occurrences of watchpoint 0 with action=8\000event=0x164\000\00000\000\000 */
{ 11957 }, /* watchpoint_1\000watchpoint\000Counts occurrences of watchpoint 1 with action=8\000event=0x264\000\00000\000\000 */
{ 12047 }, /* watchpoint_2\000watchpoint\000Counts occurrences of watchpoint 2 with action=8\000event=0x464\000\00000\000\000 */
{ 12137 }, /* watchpoint_3\000watchpoint\000Counts occurrences of watchpoint 3 with action=8\000event=0x864\000\00000\000\000 */
{ 12227 }, /* watchpoint_4\000watchpoint\000Counts occurrences of watchpoint 4 with action=8\000event=0x1064\000\00000\000\000 */
{ 12318 }, /* watchpoint_5\000watchpoint\000Counts occurrences of watchpoint 5 with action=8\000event=0x2064\000\00000\000\000 */
{ 12409 }, /* watchpoint_6\000watchpoint\000Counts occurrences of watchpoint 6 with action=8\000event=0x4064\000\00000\000\000 */
{ 12500 }, /* watchpoint_7\000watchpoint\000Counts occurrences of watchpoint 7 with action=8\000event=0x8064\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__sifive_bullet_0d[] = {
{
     .entries = pmu_events__sifive_bullet_0d_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__sifive_bullet_0d_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__sifive_p550_default_core[] = {
{ 10413 }, /* addressgen_interlock\000microarch\000Counts cycles with an address-generation interlock\000event=0x101\000\00000\000\000 */
{ 8336 }, /* atomic_memory_retired\000instruction\000Counts atomic memory instructions retired\000event=0x800\000\00000\000\000 */
{ 10911 }, /* branch_direction_misprediction\000microarch\000Counts mispredictions of conditional branch direction (taken/not taken)\000event=0x2001\000\00000\000\000 */
{ 11042 }, /* branch_target_misprediction\000microarch\000Counts mispredictions of the target PC of control-flow instructions\000event=0x4001\000\00000\000\000 */
{ 8648 }, /* conditional_branch_retired\000instruction\000Counts conditional branch instructions retired\000event=0x4000\000\00000\000\000 */
{ 10605 }, /* csr_interlock\000microarch\000Counts cycles with a CSR interlock\000event=0x401\000\00000\000\000 */
{ 10807 }, /* dcache_blocked\000microarch\000Counts cycles in which the data cache blocked an instruction\000event=0x1001\000\00000\000\000 */
{ 9950 }, /* dcache_miss\000memory\000Counts data cache misses\000event=0x202\000\00000\000\000 */
{ 10011 }, /* dcache_release\000memory\000Counts writeback requests from the data cache\000event=0x402\000\00000\000\000 */
{ 10211 }, /* dtlb_miss\000memory\000Counts Data TLB misses caused by data address translation requests\000event=0x1002\000\00000\000\000 */
{ 8083 }, /* exception_taken\000instruction\000Counts exceptions taken\000event=0x100\000\00000\000\000 */
{ 9360 }, /* fp_add_retired\000instruction\000Counts floating-point add instructions retired\000event=0x200000\000\00000\000\000 */
{ 9665 }, /* fp_div_sqrt_retired\000instruction\000Counts floating point divide or square root instructions retired\000event=0x1000000\000\00000\000\000 */
{ 11461 }, /* fp_interlock\000microarch\000Counts cycles with a floating-point interlock\000event=0x40001\000\00000\000\000 */
{ 9167 }, /* fp_load_retired\000instruction\000Counts floating-point load instructions retired\000event=0x80000\000\00000\000\000 */
{ 9454 }, /* fp_mul_retired\000instruction\000Counts floating-point multiply instructions retired\000event=0x400000\000\00000\000\000 */
{ 9553 }, /* fp_muladd_retired\000instruction\000Counts floating-point fused multiply-add instructions retired\000event=0x800000\000\00000\000\000 */
{ 9262 }, /* fp_store_retired\000instruction\000Counts floating-point store instructions retired\000event=0x100000\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 10681 }, /* icache_blocked\000microarch\000Counts cycles in which the instruction cache was not able to provide an instruction\000event=0x801\000\00000\000\000 */
{ 9882 }, /* icache_miss\000memory\000Counts instruction cache misses\000event=0x102\000\00000\000\000 */
{ 8544 }, /* integer_arithmetic_retired\000instruction\000Counts integer arithmetic instructions retired\000event=0x2000\000\00000\000\000 */
{ 9066 }, /* integer_division_retired\000instruction\000Counts integer division instructions retired\000event=0x40000\000\00000\000\000 */
{ 8152 }, /* integer_load_retired\000instruction\000Counts integer load instructions retired\000event=0x200\000\00000\000\000 */
{ 11356 }, /* integer_mul_div_interlock\000microarch\000Counts cycles with a multiply or divide interlock\000event=0x20001\000\00000\000\000 */
{ 8953 }, /* integer_multiplication_retired\000instruction\000Counts integer multiplication instructions retired\000event=0x20000\000\00000\000\000 */
{ 8243 }, /* integer_store_retired\000instruction\000Counts integer store instructions retired\000event=0x400\000\00000\000\000 */
{ 10096 }, /* itlb_miss\000memory\000Counts Instruction TLB misses caused by instruction address translation requests\000event=0x802\000\00000\000\000 */
{ 8752 }, /* jal_instruction_retired\000instruction\000Counts jump-and-link instructions retired\000event=0x8000\000\00000\000\000 */
{ 8848 }, /* jalr_instruction_retired\000instruction\000Counts indirect jump instructions (JALR) retired\000event=0x10000\000\00000\000\000 */
{ 10512 }, /* longlatency_interlock\000microarch\000Counts cycles with a long-latency interlock\000event=0x201\000\00000\000\000 */
{ 9783 }, /* other_fp_retired\000instruction\000Counts other floating-point instructions retired\000event=0x2000000\000\00000\000\000 */
{ 11166 }, /* pipeline_flush\000microarch\000Counts flushes of the core pipeline. Common causes include fence.i and CSR accesses\000event=0x8001\000\00000\000\000 */
{ 12989 }, /* pte_cache_hit\000memory\000Counts Page Table Entry cache hits\000event=0x10002\000\00000\000\000 */
{ 12912 }, /* pte_cache_miss\000memory\000Counts Page Table Entry cache misses\000event=0x8002\000\00000\000\000 */
{ 11293 }, /* replay\000microarch\000Counts instruction replays\000event=0x10001\000\00000\000\000 */
{ 8429 }, /* system_instruction_retired\000instruction\000Counts system instructions retired (CSR, WFI, MRET, etc.)\000event=0x1000\000\00000\000\000 */
{ 12821 }, /* utlb_hit\000memory\000Counts Unified TLB hits for address translation requests\000event=0x4002\000\00000\000\000 */
{ 10313 }, /* utlb_miss\000memory\000Counts Unified TLB misses caused by address translation requests\000event=0x2002\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__sifive_p550[] = {
{
     .entries = pmu_events__sifive_p550_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__sifive_p550_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__sifive_p650_default_core[] = {
{ 10413 }, /* addressgen_interlock\000microarch\000Counts cycles with an address-generation interlock\000event=0x101\000\00000\000\000 */
{ 8336 }, /* atomic_memory_retired\000instruction\000Counts atomic memory instructions retired\000event=0x800\000\00000\000\000 */
{ 10911 }, /* branch_direction_misprediction\000microarch\000Counts mispredictions of conditional branch direction (taken/not taken)\000event=0x2001\000\00000\000\000 */
{ 11042 }, /* branch_target_misprediction\000microarch\000Counts mispredictions of the target PC of control-flow instructions\000event=0x4001\000\00000\000\000 */
{ 8648 }, /* conditional_branch_retired\000instruction\000Counts conditional branch instructions retired\000event=0x4000\000\00000\000\000 */
{ 11549 }, /* core_clock_cycles\000cycle and instruction count\000Counts core clock cycles\000event=0x165\000\00000\000\000 */
{ 10605 }, /* csr_interlock\000microarch\000Counts cycles with a CSR interlock\000event=0x401\000\00000\000\000 */
{ 10807 }, /* dcache_blocked\000microarch\000Counts cycles in which the data cache blocked an instruction\000event=0x1001\000\00000\000\000 */
{ 9950 }, /* dcache_miss\000memory\000Counts data cache misses\000event=0x202\000\00000\000\000 */
{ 10011 }, /* dcache_release\000memory\000Counts writeback requests from the data cache\000event=0x402\000\00000\000\000 */
{ 10211 }, /* dtlb_miss\000memory\000Counts Data TLB misses caused by data address translation requests\000event=0x1002\000\00000\000\000 */
{ 13139 }, /* dtlb_multi_hit\000memory\000Counts Data TLB multi-hits\000event=0x40002\000\00000\000\000 */
{ 8083 }, /* exception_taken\000instruction\000Counts exceptions taken\000event=0x100\000\00000\000\000 */
{ 9360 }, /* fp_add_retired\000instruction\000Counts floating-point add instructions retired\000event=0x200000\000\00000\000\000 */
{ 9665 }, /* fp_div_sqrt_retired\000instruction\000Counts floating point divide or square root instructions retired\000event=0x1000000\000\00000\000\000 */
{ 11461 }, /* fp_interlock\000microarch\000Counts cycles with a floating-point interlock\000event=0x40001\000\00000\000\000 */
{ 9167 }, /* fp_load_retired\000instruction\000Counts floating-point load instructions retired\000event=0x80000\000\00000\000\000 */
{ 9454 }, /* fp_mul_retired\000instruction\000Counts floating-point multiply instructions retired\000event=0x400000\000\00000\000\000 */
{ 9553 }, /* fp_muladd_retired\000instruction\000Counts floating-point fused multiply-add instructions retired\000event=0x800000\000\00000\000\000 */
{ 9262 }, /* fp_store_retired\000instruction\000Counts floating-point store instructions retired\000event=0x100000\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 10681 }, /* icache_blocked\000microarch\000Counts cycles in which the instruction cache was not able to provide an instruction\000event=0x801\000\00000\000\000 */
{ 9882 }, /* icache_miss\000memory\000Counts instruction cache misses\000event=0x102\000\00000\000\000 */
{ 11637 }, /* instructions_retired\000cycle and instruction count\000Counts instructions retired\000event=0x265\000\00000\000\000 */
{ 8544 }, /* integer_arithmetic_retired\000instruction\000Counts integer arithmetic instructions retired\000event=0x2000\000\00000\000\000 */
{ 9066 }, /* integer_division_retired\000instruction\000Counts integer division instructions retired\000event=0x40000\000\00000\000\000 */
{ 8152 }, /* integer_load_retired\000instruction\000Counts integer load instructions retired\000event=0x200\000\00000\000\000 */
{ 11356 }, /* integer_mul_div_interlock\000microarch\000Counts cycles with a multiply or divide interlock\000event=0x20001\000\00000\000\000 */
{ 8953 }, /* integer_multiplication_retired\000instruction\000Counts integer multiplication instructions retired\000event=0x20000\000\00000\000\000 */
{ 8243 }, /* integer_store_retired\000instruction\000Counts integer store instructions retired\000event=0x400\000\00000\000\000 */
{ 10096 }, /* itlb_miss\000memory\000Counts Instruction TLB misses caused by instruction address translation requests\000event=0x802\000\00000\000\000 */
{ 13064 }, /* itlb_multi_hit\000memory\000Counts Instruction TLB multi-hits\000event=0x20002\000\00000\000\000 */
{ 8752 }, /* jal_instruction_retired\000instruction\000Counts jump-and-link instructions retired\000event=0x8000\000\00000\000\000 */
{ 8848 }, /* jalr_instruction_retired\000instruction\000Counts indirect jump instructions (JALR) retired\000event=0x10000\000\00000\000\000 */
{ 10512 }, /* longlatency_interlock\000microarch\000Counts cycles with a long-latency interlock\000event=0x201\000\00000\000\000 */
{ 9783 }, /* other_fp_retired\000instruction\000Counts other floating-point instructions retired\000event=0x2000000\000\00000\000\000 */
{ 11166 }, /* pipeline_flush\000microarch\000Counts flushes of the core pipeline. Common causes include fence.i and CSR accesses\000event=0x8001\000\00000\000\000 */
{ 12989 }, /* pte_cache_hit\000memory\000Counts Page Table Entry cache hits\000event=0x10002\000\00000\000\000 */
{ 12912 }, /* pte_cache_miss\000memory\000Counts Page Table Entry cache misses\000event=0x8002\000\00000\000\000 */
{ 11293 }, /* replay\000microarch\000Counts instruction replays\000event=0x10001\000\00000\000\000 */
{ 8429 }, /* system_instruction_retired\000instruction\000Counts system instructions retired (CSR, WFI, MRET, etc.)\000event=0x1000\000\00000\000\000 */
{ 11731 }, /* trace_stall\000microarch\000Counts cycles in which the core pipeline is stalled due to backpressure from the Trace Encoder\000event=0x80001\000\00000\000\000 */
{ 12821 }, /* utlb_hit\000memory\000Counts Unified TLB hits for address translation requests\000event=0x4002\000\00000\000\000 */
{ 10313 }, /* utlb_miss\000memory\000Counts Unified TLB misses caused by address translation requests\000event=0x2002\000\00000\000\000 */
{ 11867 }, /* watchpoint_0\000watchpoint\000Counts occurrences of watchpoint 0 with action=8\000event=0x164\000\00000\000\000 */
{ 11957 }, /* watchpoint_1\000watchpoint\000Counts occurrences of watchpoint 1 with action=8\000event=0x264\000\00000\000\000 */
{ 12047 }, /* watchpoint_2\000watchpoint\000Counts occurrences of watchpoint 2 with action=8\000event=0x464\000\00000\000\000 */
{ 12137 }, /* watchpoint_3\000watchpoint\000Counts occurrences of watchpoint 3 with action=8\000event=0x864\000\00000\000\000 */
{ 12227 }, /* watchpoint_4\000watchpoint\000Counts occurrences of watchpoint 4 with action=8\000event=0x1064\000\00000\000\000 */
{ 12318 }, /* watchpoint_5\000watchpoint\000Counts occurrences of watchpoint 5 with action=8\000event=0x2064\000\00000\000\000 */
{ 12409 }, /* watchpoint_6\000watchpoint\000Counts occurrences of watchpoint 6 with action=8\000event=0x4064\000\00000\000\000 */
{ 12500 }, /* watchpoint_7\000watchpoint\000Counts occurrences of watchpoint 7 with action=8\000event=0x8064\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__sifive_p650[] = {
{
     .entries = pmu_events__sifive_p650_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__sifive_p650_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__spacemit_x60_default_core[] = {
{ 15410 }, /* alu_inst\000instruction\000ALU (integer) instructions\000event=0x24\000\00000\000\000 */
{ 16357 }, /* amo_inst\000instruction\000AMO instructions\000event=0x33\000\00000\000\000 */
{ 17619 }, /* async_abort\000microarch\000Asynchronous aborts\000event=0x4c\000\00000\000\000 */
{ 16193 }, /* atomic_inst\000instruction\000Atomic instructions\000event=0x30\000\00000\000\000 */
{ 21107 }, /* bju_cp0_stall\000microarch\000 \000event=0x8a\000\00000\000\000 */
{ 21149 }, /* bju_ibuf_stall\000microarch\000 \000event=0x8b\000\00000\000\000 */
{ 21233 }, /* bju_pipedown\000microarch\000 \000event=0x8d\000\00000\000\000 */
{ 21192 }, /* bju_wb_stall\000microarch\000 \000event=0x8c\000\00000\000\000 */
{ 13342 }, /* br_inst\000branch\000Branch instructions\000event=0x3c\000\00000\000\000 */
{ 13608 }, /* br_mispred\000branch\000Branch mispredictions\000event=0x45\000\00000\000\000 */
{ 16535 }, /* bus_fence_inst\000instruction\000Bus FENCE instructions\000event=0x36\000\00000\000\000 */
{ 13207 }, /* cond_br_inst\000branch\000Conditional branch instructions\000event=1\000\00000\000\000 */
{ 13272 }, /* cond_br_mispred\000branch\000Conditional branch mispredictions\000event=2\000\00000\000\000 */
{ 15749 }, /* csr_inst\000instruction\000CSR instructions\000event=0x29\000\00000\000\000 */
{ 20549 }, /* div_buffer_hit\000microarch\000 \000event=0x80\000\00000\000\000 */
{ 15540 }, /* div_inst\000instruction\000Division instructions\000event=0x26\000\00000\000\000 */
{ 14498 }, /* dtlb_load_miss\000cache\000DTLB load misses\000event=0x15\000\00000\000\000 */
{ 14552 }, /* dtlb_store_miss\000cache\000DTLB store misses\000event=0x19\000\00000\000\000 */
{ 15803 }, /* ecall_inst\000instruction\000ECALL instructions\000event=0x2a\000\00000\000\000 */
{ 17564 }, /* ecc_interrupt\000microarch\000ECC interrupts\000event=0x4b\000\00000\000\000 */
{ 19327 }, /* eu_bju_full\000microarch\000EU BJU (Branch and Jump Unit) fulls\000event=0x6a\000\00000\000\000 */
{ 19569 }, /* eu_cp0_full\000microarch\000EU CP0 (Coprocessor 0) fulls\000event=0x6d\000\00000\000\000 */
{ 19247 }, /* eu_iu_control_full\000microarch\000EU IU (Integer Unit) control fulls\000event=0x69\000\00000\000\000 */
{ 19183 }, /* eu_iu_full\000microarch\000EU IU (Integer Unit) fulls\000event=0x68\000\00000\000\000 */
{ 19401 }, /* eu_lsu_load_full\000microarch\000EU LSU (Load and Store Unit) load fulls\000event=0x6b\000\00000\000\000 */
{ 19484 }, /* eu_lsu_store_full\000microarch\000EU LSU (Load and Store Unit) store fulls\000event=0x6c\000\00000\000\000 */
{ 19121 }, /* eu_stall\000microarch\000EU (Execution Unit) stalls\000event=0x67\000\00000\000\000 */
{ 19636 }, /* eu_vfpu_full\000microarch\000EU VFPU (Vector and Floating-point Processing Unit)\000event=0x6e\000\00000\000\000 */
{ 17355 }, /* exception\000microarch\000Exceptions\000event=0x41\000\00000\000\000 */
{ 16469 }, /* failed_sc_inst\000instruction\000Failed SC instructions\000event=0x35\000\00000\000\000 */
{ 16411 }, /* fence_inst\000instruction\000FENCE instructions\000event=0x34\000\00000\000\000 */
{ 15672 }, /* fp_div_inst\000instruction\000Floating-point division instructions\000event=0x28\000\00000\000\000 */
{ 15861 }, /* fp_inst\000instruction\000Floating-point instructions\000event=0x2b\000\00000\000\000 */
{ 16601 }, /* fp_load_inst\000instruction\000Floating-point load instructions\000event=0x37\000\00000\000\000 */
{ 16675 }, /* fp_store_inst\000instruction\000Floating-point store instructions\000event=0x38\000\00000\000\000 */
{ 18041 }, /* ib_fifo_stall\000microarch\000IB FIFO stalls\000event=0x54\000\00000\000\000 */
{ 18163 }, /* ib_ind_btd_stall\000microarch\000IB IND BTB stalls\000event=0x56\000\00000\000\000 */
{ 18096 }, /* ib_mispred_stall\000microarch\000IB misprediction stalls\000event=0x55\000\00000\000\000 */
{ 17937 }, /* ib_stall\000microarch\000IB stalls\000event=0x52\000\00000\000\000 */
{ 17982 }, /* ib_vsetvl_stall\000microarch\000IB vsetvl stalls\000event=0x53\000\00000\000\000 */
{ 18610 }, /* id_csr_bef_fence_stall\000microarch\000 \000event=0x5e\000\00000\000\000 */
{ 18456 }, /* id_flush_stall\000microarch\000ID flush stalls\000event=0x5b\000\00000\000\000 */
{ 18561 }, /* id_iid_not_vld_stall\000microarch\000 \000event=0x5d\000\00000\000\000 */
{ 18312 }, /* id_inst_pipedown\000microarch\000ID instruction pipedowns\000event=0x59\000\00000\000\000 */
{ 18661 }, /* id_mispred_stall\000microarch\000ID misprediction stalls\000event=0x5f\000\00000\000\000 */
{ 18380 }, /* id_one_inst_pipedown\000microarch\000ID one instruction pipedowns\000event=0x5a\000\00000\000\000 */
{ 18267 }, /* id_stall\000microarch\000ID stalls\000event=0x58\000\00000\000\000 */
{ 18513 }, /* id_vsetvl_fof_stall\000microarch\000 \000event=0x5c\000\00000\000\000 */
{ 17780 }, /* if_mmu_stall\000microarch\000IF-MMU stalls\000event=0x4f\000\00000\000\000 */
{ 17833 }, /* if_refill_stall\000microarch\000IF-refill stalls\000event=0x50\000\00000\000\000 */
{ 17735 }, /* if_stall\000microarch\000IF stalls\000event=0x4e\000\00000\000\000 */
{ 17481 }, /* ifu_btb_access\000microarch\000IFU (Instruction Fetch Unit) BTB accesses\000event=0x44\000\00000\000\000 */
{ 17402 }, /* ifu_btb_miss\000microarch\000IFU (Instruction Fetch Unit) BTB misses\000event=0x43\000\00000\000\000 */
{ 13465 }, /* indirect_br_inst\000branch\000Indirect branch instructions\000event=0x3e\000\00000\000\000 */
{ 13534 }, /* indirect_br_mispred\000branch\000Indirect branch mispredictions\000event=0x42\000\00000\000\000 */
{ 17308 }, /* interrupt\000microarch\000Interrupts\000event=0x40\000\00000\000\000 */
{ 17892 }, /* ip_stall\000microarch\000IP stalls\000event=0x51\000\00000\000\000 */
{ 18224 }, /* iq_full\000microarch\000IQ fulls\000event=0x57\000\00000\000\000 */
{ 17677 }, /* issued_inst\000microarch\000Issued instructions\000event=0x4d\000\00000\000\000 */
{ 14608 }, /* itlb_load_miss\000cache\000ITLB load misses\000event=0x1b\000\00000\000\000 */
{ 19821 }, /* iu_div_ex1_stall_pipe0\000microarch\000 \000event=0x71\000\00000\000\000 */
{ 19971 }, /* iu_div_ex1_stall_pipe1\000microarch\000 \000event=0x74\000\00000\000\000 */
{ 20458 }, /* iu_div_uncommit\000microarch\000 \000event=0x7e\000\00000\000\000 */
{ 20414 }, /* iu_div_wb_stall\000microarch\000 \000event=0x7d\000\00000\000\000 */
{ 19872 }, /* iu_dp_pipe_stall_pipe1\000microarch\000 \000event=0x72\000\00000\000\000 */
{ 19727 }, /* iu_dp_stall_pipe0\000microarch\000 \000event=0x6f\000\00000\000\000 */
{ 20022 }, /* iu_dp_uncommit_pipe0\000microarch\000 \000event=0x75\000\00000\000\000 */
{ 20173 }, /* iu_dp_uncommit_pipe1\000microarch\000 \000event=0x78\000\00000\000\000 */
{ 20123 }, /* iu_dp_waw_stall_pipe0\000microarch\000 \000event=0x77\000\00000\000\000 */
{ 20274 }, /* iu_dp_waw_stall_pipe1\000microarch\000 \000event=0x7a\000\00000\000\000 */
{ 20071 }, /* iu_dp_wb_conflict_pipe0\000microarch\000 \000event=0x76\000\00000\000\000 */
{ 20222 }, /* iu_dp_wb_conflict_pipe1\000microarch\000 \000event=0x79\000\00000\000\000 */
{ 19773 }, /* iu_mult_stall_pipe0\000microarch\000 \000event=0x70\000\00000\000\000 */
{ 19923 }, /* iu_mult_stall_pipe1\000microarch\000 \000event=0x73\000\00000\000\000 */
{ 20369 }, /* iu_mult_uncommit\000microarch\000 \000event=0x7c\000\00000\000\000 */
{ 20324 }, /* iu_mult_wb_stall\000microarch\000 \000event=0x7b\000\00000\000\000 */
{ 14662 }, /* jtlb_miss\000cache\000JTLB misses\000event=0xa3\000\00000\000\000 */
{ 14706 }, /* l1d_access\000cache\000L1 D-cache accesses\000event=0xaa\000\00000\000\000 */
{ 14882 }, /* l1d_amr_active\000cache\000L1 D-cache AMR actives\000event=0xad\000\00000\000\000 */
{ 14808 }, /* l1d_excl_evict\000cache\000L1 D-cache exclusive evictions to L2\000event=0xac\000\00000\000\000 */
{ 14074 }, /* l1d_load_access\000cache\000L1 D-cache load accesses\000event=6\000\00000\000\000 */
{ 14018 }, /* l1d_load_miss\000cache\000L1 D-cache load misses\000event=5\000\00000\000\000 */
{ 14759 }, /* l1d_miss\000cache\000L1 D-cache misses\000event=0xab\000\00000\000\000 */
{ 15012 }, /* l1d_prefetch_hit\000cache\000L1 D-cache prefetch hits\000event=0xaf\000\00000\000\000 */
{ 14942 }, /* l1d_prefetch_refill\000cache\000L1 D-cache prefetch refills\000event=0xae\000\00000\000\000 */
{ 14192 }, /* l1d_store_access\000cache\000L1 D-cache store accesses\000event=0xa\000\00000\000\000 */
{ 14134 }, /* l1d_store_miss\000cache\000L1 D-cache store misses\000event=9\000\00000\000\000 */
{ 14314 }, /* l1i_load_access\000cache\000L1 I-cache load accesses\000event=0xc\000\00000\000\000 */
{ 14256 }, /* l1i_load_miss\000cache\000L1 I-cache load misses\000event=0xb\000\00000\000\000 */
{ 14442 }, /* l1i_prefetch\000cache\000L1 I-cache prefetches\000event=0xe\000\00000\000\000 */
{ 14376 }, /* l1i_prefetch_miss\000cache\000L1 I-cache prefetch misses\000event=0xd\000\00000\000\000 */
{ 15076 }, /* l2_access\000cache\000L2 cache accesses\000event=0xb8\000\00000\000\000 */
{ 15172 }, /* l2_load_access\000cache\000L2 cache load accesses\000event=0xba\000\00000\000\000 */
{ 15232 }, /* l2_load_stall\000cache\000L2 cache load stalls\000event=0xbb\000\00000\000\000 */
{ 15126 }, /* l2_miss\000cache\000L2 cache misses\000event=0xb9\000\00000\000\000 */
{ 15289 }, /* l2_store_access\000cache\000L2 cache store accesses\000event=0xbc\000\00000\000\000 */
{ 15351 }, /* l2_store_stall\000cache\000L2 cache store stalls\000event=0xbd\000\00000\000\000 */
{ 15983 }, /* load_inst\000instruction\000Load instructions\000event=0x2d\000\00000\000\000 */
{ 13974 }, /* long_jump\000branch\000Long jumps\000event=0x4a\000\00000\000\000 */
{ 16253 }, /* lr_inst\000instruction\000LR instructions\000event=0x31\000\00000\000\000 */
{ 22286 }, /* lsu_fence_stall\000microarch\000 \000event=0xa4\000\00000\000\000 */
{ 22377 }, /* lsu_load_commit_stall\000microarch\000 \000event=0xa6\000\00000\000\000 */
{ 22427 }, /* lsu_load_raw_stall\000microarch\000 \000event=0xa7\000\00000\000\000 */
{ 22330 }, /* lsu_load_waw_stall\000microarch\000 \000event=0xa5\000\00000\000\000 */
{ 22474 }, /* lsu_store_commit_stall\000microarch\000 \000event=0xa8\000\00000\000\000 */
{ 17091 }, /* m_mode_cycle\000microarch\000M-mode cycles\000event=0x20\000\00000\000\000 */
{ 20502 }, /* mult_inner_forward\000microarch\000 \000event=0x7f\000\00000\000\000 */
{ 15474 }, /* mult_inst\000instruction\000Multiplication instructions\000event=0x25\000\00000\000\000 */
{ 17250 }, /* pipeline_flush\000microarch\000Pipeline flushes\000event=0x3f\000\00000\000\000 */
{ 19023 }, /* rf_csr_aft_fence_stall\000microarch\000 \000event=0x65\000\00000\000\000 */
{ 18773 }, /* rf_inst_pipedown\000microarch\000RF instruction pipedowns\000event=0x61\000\00000\000\000 */
{ 18841 }, /* rf_one_inst_pipedown\000microarch\000RF one instruction pipedowns\000event=0x62\000\00000\000\000 */
{ 18970 }, /* rf_raw_stall\000microarch\000RF RAW stalls\000event=0x64\000\00000\000\000 */
{ 18728 }, /* rf_stall\000microarch\000RF stalls\000event=0x60\000\00000\000\000 */
{ 19074 }, /* rf_structure_stall\000microarch\000 \000event=0x66\000\00000\000\000 */
{ 18917 }, /* rf_waw_stall\000microarch\000RF WAW stalls\000event=0x63\000\00000\000\000 */
{ 22101 }, /* rtu_bju_not_no_op\000microarch\000 \000event=0x9f\000\00000\000\000 */
{ 22147 }, /* rtu_cp0_not_no_op\000microarch\000 \000event=0xa0\000\00000\000\000 */
{ 21757 }, /* rtu_flush_cycle\000microarch\000 \000event=0x98\000\00000\000\000 */
{ 22056 }, /* rtu_iu_not_no_op\000microarch\000 \000event=0x9e\000\00000\000\000 */
{ 22193 }, /* rtu_lsu_not_no_op\000microarch\000 \000event=0xa1\000\00000\000\000 */
{ 21851 }, /* rtu_only_bju_not_no_op\000microarch\000 \000event=0x9a\000\00000\000\000 */
{ 21902 }, /* rtu_only_cp0_not_no_op\000microarch\000 \000event=0x9b\000\00000\000\000 */
{ 21801 }, /* rtu_only_iu_not_no_op\000microarch\000 \000event=0x99\000\00000\000\000 */
{ 21953 }, /* rtu_only_lsu_not_no_op\000microarch\000 \000event=0x9c\000\00000\000\000 */
{ 22004 }, /* rtu_only_vfpu_not_no_op\000microarch\000 \000event=0x9d\000\00000\000\000 */
{ 22239 }, /* rtu_vfpu_not_no_op\000microarch\000 \000event=0xa2\000\00000\000\000 */
{ 17144 }, /* s_mode_cycle\000microarch\000S-mode cycles\000event=0x21\000\00000\000\000 */
{ 16305 }, /* sc_inst\000instruction\000SC instructions\000event=0x32\000\00000\000\000 */
{ 17023 }, /* stalled_cycle_backend\000microarch\000Stalled cycles backend\000event=4\000\00000\000\000 */
{ 16953 }, /* stalled_cycle_frontend\000microarch\000Stalled cycles frontend\000event=3\000\00000\000\000 */
{ 15925 }, /* store_inst\000instruction\000Store instructions\000event=0x2c\000\00000\000\000 */
{ 13741 }, /* taken_br_mispred\000branch\000Taken branch mispredictions\000event=0x47\000\00000\000\000 */
{ 13809 }, /* taken_cond_br_inst\000branch\000Taken conditional branch instructions\000event=0x48\000\00000\000\000 */
{ 13889 }, /* taken_cond_br_mispred\000branch\000Taken conditional branch mispredictions\000event=0x49\000\00000\000\000 */
{ 17197 }, /* u_mode_cycle\000microarch\000U-mode cycles\000event=0x22\000\00000\000\000 */
{ 16039 }, /* unaligned_load_inst\000instruction\000Unaligned load instructions\000event=0x2e\000\00000\000\000 */
{ 16115 }, /* unaligned_store_inst\000instruction\000Unaligned store instructions\000event=0x2f\000\00000\000\000 */
{ 13393 }, /* uncond_br_inst\000branch\000Unconditional branch instructions\000event=0x3d\000\00000\000\000 */
{ 13664 }, /* uncond_br_mispred\000branch\000Unconditional branch mispredictions\000event=0x46\000\00000\000\000 */
{ 15599 }, /* vector_div_inst\000instruction\000Vector division instructions\000event=0x27\000\00000\000\000 */
{ 16893 }, /* vector_inst\000instruction\000Vector instructions\000event=0x3b\000\00000\000\000 */
{ 16751 }, /* vector_load_inst\000instruction\000Vector load instructions\000event=0x39\000\00000\000\000 */
{ 21713 }, /* vector_micro_op\000microarch\000 \000event=0x97\000\00000\000\000 */
{ 16821 }, /* vector_store_inst\000instruction\000Vector store instructions\000event=0x3a\000\00000\000\000 */
{ 22525 }, /* vidu_rf_no_pipedown\000microarch\000 \000event=0xa9\000\00000\000\000 */
{ 21580 }, /* vidu_total_cycle\000microarch\000 \000event=0x94\000\00000\000\000 */
{ 21625 }, /* vidu_vec0_cycle\000microarch\000 \000event=0x95\000\00000\000\000 */
{ 21362 }, /* vidu_vec0_depend_stall\000microarch\000 \000event=0x90\000\00000\000\000 */
{ 21274 }, /* vidu_vec0_stall\000microarch\000 \000event=0x8e\000\00000\000\000 */
{ 21413 }, /* vidu_vec0_struct_hazard_stall\000microarch\000 \000event=0x91\000\00000\000\000 */
{ 21669 }, /* vidu_vec1_cycle\000microarch\000 \000event=0x96\000\00000\000\000 */
{ 21471 }, /* vidu_vec1_depend_stall\000microarch\000 \000event=0x92\000\00000\000\000 */
{ 21318 }, /* vidu_vec1_stall\000microarch\000 \000event=0x8f\000\00000\000\000 */
{ 21522 }, /* vidu_vec1_struct_hazard_stall\000microarch\000 \000event=0x93\000\00000\000\000 */
{ 21066 }, /* vpu_div_busy\000microarch\000 \000event=0x89\000\00000\000\000 */
{ 20760 }, /* vpu_hazard_stall_pipe0\000microarch\000 \000event=0x83\000\00000\000\000 */
{ 20913 }, /* vpu_hazard_stall_pipe1\000microarch\000 \000event=0x86\000\00000\000\000 */
{ 20592 }, /* vpu_stall_pipe0\000microarch\000VPU (Vector Processing Unit) pipe0 stalls\000event=0x81\000\00000\000\000 */
{ 20676 }, /* vpu_stall_pipe1\000microarch\000VPU (Vector Processing Unit) pipe1 stalls\000event=0x82\000\00000\000\000 */
{ 20811 }, /* vpu_uncommit_stall_pipe0\000microarch\000 \000event=0x84\000\00000\000\000 */
{ 20964 }, /* vpu_uncommit_stall_pipe1\000microarch\000 \000event=0x87\000\00000\000\000 */
{ 20864 }, /* vpu_vlsu_stall_pipe0\000microarch\000 \000event=0x85\000\00000\000\000 */
{ 21017 }, /* vpu_vlsu_stall_pipe1\000microarch\000 \000event=0x88\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__spacemit_x60[] = {
{
     .entries = pmu_events__spacemit_x60_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__spacemit_x60_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__starfive_dubhe_80_default_core[] = {
{ 24044 }, /* access_dtlb\000common\000access DTLB\000event=0x17\000\00000\000\000 */
{ 22673 }, /* access_mmu_pte_c\000common\000access MMU PTE-Cache\000event=3\000\00000\000\000 */
{ 22573 }, /* access_mmu_stlb\000common\000access MMU STLB\000event=1\000\00000\000\000 */
{ 23132 }, /* bpu_br_miss\000common\000condition branch instruction miss\000event=0xb\000\00000\000\000 */
{ 23060 }, /* bpu_br_retire\000common\000condition branch instruction retire\000event=0xa\000\00000\000\000 */
{ 23975 }, /* bru_ret_ijr_ins\000common\000BRU retire an IJR instruction\000event=0x16\000\00000\000\000 */
{ 22851 }, /* btb_prediction_miss\000common\000BTB prediction miss\000event=6\000\00000\000\000 */
{ 23812 }, /* dec_val_rob_nordy\000common\000DEC is valid and ROB is not ready\000event=0x14\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 23485 }, /* ibuf_noval_id_rdy\000common\000IBUF not valid while ID ready\000event=0x10\000\00000\000\000 */
{ 23415 }, /* ibuf_val_id_nordy\000common\000IBUF valid while ID not ready\000event=0xf\000\00000\000\000 */
{ 23016 }, /* icache_miss\000common\000ICache miss\000event=9\000\00000\000\000 */
{ 23322 }, /* indirect_jr_miss\000common\000indirect JR instruction miss (inlcude without target)\000event=0xe\000\00000\000\000 */
{ 22911 }, /* itlb_miss\000common\000ITLB miss\000event=7\000\00000\000\000 */
{ 24720 }, /* l2c_pf_hit\000common\000L2C data-prefetcher hit\000event=0x22\000\00000\000\000 */
{ 24658 }, /* l2c_pf_req\000common\000L2C data-prefetcher request\000event=0x21\000\00000\000\000 */
{ 24134 }, /* load_ins_dcache\000common\000load instruction access DCache\000event=0x19\000\00000\000\000 */
{ 24204 }, /* load_ins_miss_dcache\000common\000load instruction miss DCache\000event=0x1a\000\00000\000\000 */
{ 24542 }, /* load_miss_scache\000common\000load miss SCache\000event=0x1f\000\00000\000\000 */
{ 24432 }, /* load_scache\000common\000load access SCache\000event=0x1d\000\00000\000\000 */
{ 24091 }, /* miss_dtlb\000common\000miss DTLB\000event=0x18\000\00000\000\000 */
{ 22731 }, /* miss_mmu_pte_c\000common\000miss MMU PTE-Cache\000event=4\000\00000\000\000 */
{ 22625 }, /* miss_mmu_stlb\000common\000miss MMU STLB\000event=2\000\00000\000\000 */
{ 23887 }, /* ood_flush_ls_dep\000common\000out of order flush due to load/store dependency\000event=0x15\000\00000\000\000 */
{ 23748 }, /* ren_cp_nordy\000common\000REN checkpoint is not ready\000event=0x13\000\00000\000\000 */
{ 23649 }, /* ren_fp_phy_reg_nordy\000common\000REN floating point physical register file is not ready\000event=0x12\000\00000\000\000 */
{ 23556 }, /* ren_int_phy_reg_nordy\000common\000REN integer physical register file is not ready\000event=0x11\000\00000\000\000 */
{ 23263 }, /* ret_ins_miss\000common\000return instruction miss\000event=0xd\000\00000\000\000 */
{ 23200 }, /* ret_ins_retire\000common\000return instruction retire\000event=0xc\000\00000\000\000 */
{ 22785 }, /* rob_flush\000common\000ROB flush (all kinds of exceptions)\000event=5\000\00000\000\000 */
{ 24277 }, /* store_ins_dcache\000common\000store/amo instruction access DCache\000event=0x1b\000\00000\000\000 */
{ 24353 }, /* store_ins_miss_dcache\000common\000store/amo instruction miss DCache\000event=0x1c\000\00000\000\000 */
{ 24599 }, /* store_miss_scache\000common\000store miss SCache\000event=0x20\000\00000\000\000 */
{ 24486 }, /* store_scache\000common\000store access SCache\000event=0x1e\000\00000\000\000 */
{ 22951 }, /* sync_del_fetch_g\000common\000SYNC delivery a fetch-group\000event=8\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__starfive_dubhe_80[] = {
{
     .entries = pmu_events__starfive_dubhe_80_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__starfive_dubhe_80_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__thead_c900_legacy_default_core[] = {
{ 27364 }, /* branch_direction_misprediction\000microarch\000Branch misprediction in BTB\000event=0x1b\000\00000\000\000 */
{ 27449 }, /* branch_direction_prediction\000microarch\000All branch prediction in BTB\000event=0x1c\000\00000\000This event including both successful prediction and failed prediction in BTB\000 */
{ 24943 }, /* dtlb_miss\000cache\000D-UTLB miss\000event=4\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 26816 }, /* idu_rf_instruction\000microarch\000retired instruction count of Instruction decode unit in RF (Register File) stage\000event=0x16\000\00000\000\000 */
{ 26610 }, /* idu_rf_pipe_fail\000microarch\000Instruction decode unit launch pipeline failed in RF state\000event=0x14\000\00000\000\000 */
{ 26712 }, /* idu_rf_reg_fail\000microarch\000Instruction decode unit launch register file fail in RF state\000event=0x15\000\00000\000\000 */
{ 28032 }, /* idu_stalled_cycle\000microarch\000hpcp_backend_stall Number of stall cycles of the instruction decoding unit (IDU) and next-level pipeline unit\000event=0x28\000\00000\000\000 */
{ 27929 }, /* ifu_stalled_cycle\000microarch\000Number of stall cycles of the instruction fetch unit (IFU)\000event=0x27\000\00000\000\000 */
{ 25889 }, /* inst_alu\000instruction\000Retired ALU instructions\000event=0x1d\000\00000\000\000 */
{ 25628 }, /* inst_branch\000instruction\000Retired branch instructions\000event=7\000\00000\000\000 */
{ 25547 }, /* inst_branch_mispredict\000instruction\000Mispredicted branch instructions\000event=6\000\00000\000\000 */
{ 26089 }, /* inst_csr\000instruction\000Retired CSR instructions\000event=0x20\000\00000\000\000 */
{ 26351 }, /* inst_ecall\000instruction\000Retired ecall instructions\000event=0x25\000\00000\000\000 */
{ 26489 }, /* inst_fp\000instruction\000Retired FPU instructions\000event=0x2a\000\00000\000\000 */
{ 25765 }, /* inst_jmp\000instruction\000Retired jmp instructions\000event=9\000\00000\000\000 */
{ 25693 }, /* inst_jmp_mispredict\000instruction\000Indirect branch mispredict\000event=8\000\00000\000\000 */
{ 25951 }, /* inst_ldst\000instruction\000Retired Load/Store instructions\000event=0x1e\000\00000\000\000 */
{ 26417 }, /* inst_long_jp\000instruction\000Retired long jump instructions\000event=0x26\000\00000\000\000 */
{ 25824 }, /* inst_store\000instruction\000Retired store instructions\000event=0xb\000\00000\000\000 */
{ 26151 }, /* inst_sync\000instruction\000Retired sync instructions (AMO/LR/SC instructions)\000event=0x21\000\00000\000\000 */
{ 26240 }, /* inst_unaligned_access\000instruction\000Retired Store/Load instructions with unaligned memory access\000event=0x22\000\00000\000\000 */
{ 26021 }, /* inst_vector\000instruction\000Retired Vector instructions\000event=0x1f\000\00000\000\000 */
{ 27608 }, /* interrupt_ack_count\000microarch\000acknowledged interrupt count\000event=0x23\000\00000\000\000 */
{ 27683 }, /* interrupt_off_cycle\000microarch\000PLIC arbitration time when the interrupt is not responded\000event=0x24\000\00000\000The arbitration time is recorded while meeting any of the following:\n- CPU is M-mode and MIE == 0\n- CPU is S-mode and delegation and SIE == 0\n\000 */
{ 24902 }, /* itlb_miss\000cache\000I-UTLB miss\000event=3\000\00000\000\000 */
{ 24984 }, /* jtlb_miss\000cache\000JTLB miss\000event=5\000\00000\000\000 */
{ 25023 }, /* l1_dcache_read_access\000cache\000L1 data cache read access\000event=0xc\000\00000\000\000 */
{ 25092 }, /* l1_dcache_read_miss\000cache\000L1 data cache read miss\000event=0xd\000\00000\000\000 */
{ 25157 }, /* l1_dcache_write_access\000cache\000L1 data cache write access\000event=0xe\000\00000\000\000 */
{ 25228 }, /* l1_dcache_write_miss\000cache\000L1 data cache write miss\000event=0xf\000\00000\000\000 */
{ 24778 }, /* l1_icache_access\000cache\000L1 instruction cache access\000event=1\000\00000\000\000 */
{ 24842 }, /* l1_icache_miss\000cache\000L1 instruction cache miss\000event=2\000\00000\000\000 */
{ 25295 }, /* ll_cache_read_access\000cache\000LL Cache read access\000event=0x10\000\00000\000\000 */
{ 25359 }, /* ll_cache_read_miss\000cache\000LL Cache read miss\000event=0x11\000\00000\000\000 */
{ 25419 }, /* ll_cache_write_access\000cache\000LL Cache write access\000event=0x12\000\00000\000\000 */
{ 25485 }, /* ll_cache_write_miss\000cache\000LL Cache write miss\000event=0x13\000\00000\000\000 */
{ 26942 }, /* lsu_4k_stall\000microarch\000LSU stall times for long distance data access (Over 4K)\000event=0x17\000\00000\000This stall occurs when translate virtual address with page offset over 4k\000 */
{ 27110 }, /* lsu_other_stall\000microarch\000LSU stall times for other reasons (except the 4k stall)\000event=0x18\000\00000\000\000 */
{ 26550 }, /* lsu_spec_fail\000microarch\000LSU speculation fail\000event=0xa\000\00000\000\000 */
{ 27282 }, /* lsu_sq_data_discard\000microarch\000LSU store queue discard data (uops)\000event=0x1a\000\00000\000\000 */
{ 27208 }, /* lsu_sq_other_dis\000microarch\000LSU store queue discard others\000event=0x19\000\00000\000\000 */
{ 28186 }, /* sync_stall\000microarch\000Sync instruction stall cycle fence/fence.i/sync/sfence\000event=0x29\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__thead_c900_legacy[] = {
{
     .entries = pmu_events__thead_c900_legacy_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__thead_c900_legacy_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__test_soc_cpu_default_core[] = {
{ 28278 }, /* bp_l1_btb_correct\000branch\000L1 BTB Correction\000event=0x8a\000\00000\000\000 */
{ 28337 }, /* bp_l2_btb_correct\000branch\000L2 BTB Correction\000event=0x8b\000\00000\000\000 */
{ 28590 }, /* dispatch_blocked.any\000other\000Memory cluster signals to block micro-op dispatch for any reason\000event=9,period=200000,umask=0x20\000\00000\000\000 */
{ 28720 }, /* eist_trans\000other\000Number of Enhanced Intel SpeedStep(R) Technology (EIST) transitions\000event=0x3a,period=200000\000\00000\000\000 */
{ 28396 }, /* l3_cache_rd\000cache\000L3 cache access, read\000event=0x40\000\00000\000Attributable Level 3 cache access, read\000 */
{ 28491 }, /* segment_reg_loads.any\000other\000Number of segment register loads\000event=6,period=200000,umask=0x80\000\00000\000\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_hisi_sccl_ddrc[] = {
{ 28850 }, /* uncore_hisi_ddrc.flux_wcmd\000uncore\000DDRC write commands\000event=2\000\00000\000DDRC write commands\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_hisi_sccl_l3c[] = {
{ 29329 }, /* uncore_hisi_l3c.rd_hit_cpipe\000uncore\000Total read hits\000event=7\000\00000\000Total read hits\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_uncore_cbox[] = {
{ 29179 }, /* event-hyphen\000uncore\000UNC_CBO_HYPHEN\000event=0xe0\000\00000\000UNC_CBO_HYPHEN\000 */
{ 29244 }, /* event-two-hyph\000uncore\000UNC_CBO_TWO_HYPH\000event=0xc0\000\00000\000UNC_CBO_TWO_HYPH\000 */
{ 28948 }, /* unc_cbo_xsnp_response.miss_eviction\000uncore\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000event=0x22,umask=0x81\000\00000\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_uncore_imc[] = {
{ 29539 }, /* uncore_imc.cache_hits\000uncore\000Total cache hits\000event=0x34\000\00000\000Total cache hits\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_uncore_imc_free_running[] = {
{ 29433 }, /* uncore_imc_free_running.cache_miss\000uncore\000Total cache misses\000event=0x12\000\00000\000Total cache misses\000 */

};

const struct pmu_table_entry pmu_events__test_soc_cpu[] = {
{
     .entries = pmu_events__test_soc_cpu_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_hisi_sccl_ddrc,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_hisi_sccl_ddrc),
     .pmu_name = { 28835 /* hisi_sccl,ddrc\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_hisi_sccl_l3c,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_hisi_sccl_l3c),
     .pmu_name = { 29315 /* hisi_sccl,l3c\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_uncore_cbox,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_uncore_cbox),
     .pmu_name = { 28936 /* uncore_cbox\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_uncore_imc,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_uncore_imc),
     .pmu_name = { 29528 /* uncore_imc\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_uncore_imc_free_running,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_uncore_imc_free_running),
     .pmu_name = { 29409 /* uncore_imc_free_running\000 */ },
},
};

static const struct compact_pmu_event pmu_metrics__test_soc_cpu_default_core[] = {
{ 29961 }, /* CPI\000\0001 / IPC\000\000\000\000\000\000\000\00000 */
{ 30642 }, /* DCache_L2_All\000\000DCache_L2_All_Hits + DCache_L2_All_Miss\000\000\000\000\000\000\000\00000 */
{ 30414 }, /* DCache_L2_All_Hits\000\000l2_rqsts.demand_data_rd_hit + l2_rqsts.pf_hit + l2_rqsts.rfo_hit\000\000\000\000\000\000\000\00000 */
{ 30508 }, /* DCache_L2_All_Miss\000\000max(l2_rqsts.all_demand_data_rd - l2_rqsts.demand_data_rd_hit, 0) + l2_rqsts.pf_miss + l2_rqsts.rfo_miss\000\000\000\000\000\000\000\00000 */
{ 30706 }, /* DCache_L2_Hits\000\000d_ratio(DCache_L2_All_Hits, DCache_L2_All)\000\000\000\000\000\000\000\00000 */
{ 30774 }, /* DCache_L2_Misses\000\000d_ratio(DCache_L2_All_Miss, DCache_L2_All)\000\000\000\000\000\000\000\00000 */
{ 30046 }, /* Frontend_Bound_SMT\000\000idq_uops_not_delivered.core / (4 * (cpu_clk_unhalted.thread / 2 * (1 + cpu_clk_unhalted.one_thread_active / cpu_clk_unhalted.ref_xclk)))\000\000\000\000\000\000\000\00000 */
{ 29983 }, /* IPC\000group1\000inst_retired.any / cpu_clk_unhalted.thread\000\000\000\000\000\000\000\00000 */
{ 30908 }, /* L1D_Cache_Fill_BW\000\00064 * l1d.replacement / 1e9 / duration_time\000\000\000\000\000\000\000\00000 */
{ 30844 }, /* M1\000\000ipc + M2\000\000\000\000\000\000\000\00000 */
{ 30866 }, /* M2\000\000ipc + M1\000\000\000\000\000\000\000\00000 */
{ 30888 }, /* M3\000\0001 / M3\000\000\000\000\000\000\000\00000 */
{ 30343 }, /* cache_miss_cycles\000group1\000dcache_miss_cpi + icache_miss_cycles\000\000\000\000\000\000\000\00000 */
{ 30212 }, /* dcache_miss_cpi\000\000l1d\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000 */
{ 30276 }, /* icache_miss_cycles\000\000l1i\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000 */

};

const struct pmu_table_entry pmu_metrics__test_soc_cpu[] = {
{
     .entries = pmu_metrics__test_soc_cpu_default_core,
     .num_entries = ARRAY_SIZE(pmu_metrics__test_soc_cpu_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__test_soc_sys_uncore_sys_ccn_pmu[] = {
{ 29728 }, /* sys_ccn_pmu.read_cycles\000uncore\000ccn read-cycles event\000config=0x2c\0000x01\00000\000\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_sys_uncore_sys_cmn_pmu[] = {
{ 29821 }, /* sys_cmn_pmu.hnf_cache_miss\000uncore\000Counts total cache misses in first lookup result (high priority)\000eventid=1,type=5\000(434|436|43c|43a).*\00000\000\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_sys_uncore_sys_ddr_pmu[] = {
{ 29636 }, /* sys_ddr_pmu.write_cycles\000uncore\000ddr write-cycles event\000event=0x2b\000v8\00000\000\000 */

};

const struct pmu_table_entry pmu_events__test_soc_sys[] = {
{
     .entries = pmu_events__test_soc_sys_uncore_sys_ccn_pmu,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_sys_uncore_sys_ccn_pmu),
     .pmu_name = { 29709 /* uncore_sys_ccn_pmu\000 */ },
},
{
     .entries = pmu_events__test_soc_sys_uncore_sys_cmn_pmu,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_sys_uncore_sys_cmn_pmu),
     .pmu_name = { 29802 /* uncore_sys_cmn_pmu\000 */ },
},
{
     .entries = pmu_events__test_soc_sys_uncore_sys_ddr_pmu,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_sys_uncore_sys_ddr_pmu),
     .pmu_name = { 29617 /* uncore_sys_ddr_pmu\000 */ },
},
};


/* Struct used to make the PMU event table implementation opaque to callers. */
struct pmu_events_table {
        const struct pmu_table_entry *pmus;
        uint32_t num_pmus;
};

/* Struct used to make the PMU metric table implementation opaque to callers. */
struct pmu_metrics_table {
        const struct pmu_table_entry *pmus;
        uint32_t num_pmus;
};

/*
 * Map a CPU to its table of PMU events. The CPU is identified by the
 * cpuid field, which is an arch-specific identifier for the CPU.
 * The identifier specified in tools/perf/pmu-events/arch/xxx/mapfile
 * must match the get_cpuid_str() in tools/perf/arch/xxx/util/header.c)
 *
 * The  cpuid can contain any character other than the comma.
 */
struct pmu_events_map {
        const char *arch;
        const char *cpuid;
        struct pmu_events_table event_table;
        struct pmu_metrics_table metric_table;
};

/*
 * Global table mapping each known CPU for the architecture to its
 * table of PMU events.
 */
const struct pmu_events_map pmu_events_map[] = {
{
	.arch = "common",
	.cpuid = "common",
	.event_table = {
		.pmus = pmu_events__common,
		.num_pmus = ARRAY_SIZE(pmu_events__common),
	},
	.metric_table = {},
},
{
	.arch = "riscv",
	.cpuid = "0x489-0x8000000000000007-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__sifive_bullet,
		.num_pmus = ARRAY_SIZE(pmu_events__sifive_bullet)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x489-0x8000000000000[1-9a-e]07-0x[78ac][[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__sifive_bullet_07,
		.num_pmus = ARRAY_SIZE(pmu_events__sifive_bullet_07)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x489-0x8000000000000[1-9a-e]07-0xd[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__sifive_bullet_0d,
		.num_pmus = ARRAY_SIZE(pmu_events__sifive_bullet_0d)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x489-0x8000000000000008-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__sifive_p550,
		.num_pmus = ARRAY_SIZE(pmu_events__sifive_p550)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x489-0x8000000000000[1-6]08-0x[9b][[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__sifive_p650,
		.num_pmus = ARRAY_SIZE(pmu_events__sifive_p650)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x5b7-0x0-0x0",
	.event_table = {
		.pmus = pmu_events__thead_c900_legacy,
		.num_pmus = ARRAY_SIZE(pmu_events__thead_c900_legacy)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x67e-0x80000000db0000[89]0-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__starfive_dubhe_80,
		.num_pmus = ARRAY_SIZE(pmu_events__starfive_dubhe_80)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x31e-0x8000000000008a45-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__andes_ax45,
		.num_pmus = ARRAY_SIZE(pmu_events__andes_ax45)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x710-0x8000000058000001-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__spacemit_x60,
		.num_pmus = ARRAY_SIZE(pmu_events__spacemit_x60)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "testarch",
	.cpuid = "testcpu",
	.event_table = {
		.pmus = pmu_events__test_soc_cpu,
		.num_pmus = ARRAY_SIZE(pmu_events__test_soc_cpu),
	},
	.metric_table = {
		.pmus = pmu_metrics__test_soc_cpu,
		.num_pmus = ARRAY_SIZE(pmu_metrics__test_soc_cpu),
	}
},
{
	.arch = 0,
	.cpuid = 0,
	.event_table = { 0, 0 },
	.metric_table = { 0, 0 },
}
};

struct pmu_sys_events {
	const char *name;
	struct pmu_events_table event_table;
	struct pmu_metrics_table metric_table;
};

static const struct pmu_sys_events pmu_sys_event_tables[] = {
	{
		.event_table = {
			.pmus = pmu_events__test_soc_sys,
			.num_pmus = ARRAY_SIZE(pmu_events__test_soc_sys)
		},
		.name = "pmu_events__test_soc_sys",
	},
	{
		.event_table = { 0, 0 },
		.metric_table = { 0, 0 },
	},
};

static void decompress_event(int offset, struct pmu_event *pe)
{
	const char *p = &big_c_string[offset];

	pe->name = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->topic = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->desc = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->event = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->compat = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->deprecated = *p - '0';
	p++;
	pe->perpkg = *p - '0';
	p++;
	pe->unit = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->long_desc = (*p == '\0' ? NULL : p);
}

static void decompress_metric(int offset, struct pmu_metric *pm)
{
	const char *p = &big_c_string[offset];

	pm->metric_name = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metric_group = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metric_expr = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metric_threshold = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->desc = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->long_desc = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->unit = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->compat = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metricgroup_no_group = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->default_metricgroup_name = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->aggr_mode = *p - '0';
	p++;
	pm->event_grouping = *p - '0';
}

static int pmu_events_table__for_each_event_pmu(const struct pmu_events_table *table,
                                                const struct pmu_table_entry *pmu,
                                                pmu_event_iter_fn fn,
                                                void *data)
{
        int ret;
        struct pmu_event pe = {
                .pmu = &big_c_string[pmu->pmu_name.offset],
        };

        for (uint32_t i = 0; i < pmu->num_entries; i++) {
                decompress_event(pmu->entries[i].offset, &pe);
                if (!pe.name)
                        continue;
                ret = fn(&pe, table, data);
                if (ret)
                        return ret;
        }
        return 0;
 }

static int pmu_events_table__find_event_pmu(const struct pmu_events_table *table,
                                            const struct pmu_table_entry *pmu,
                                            const char *name,
                                            pmu_event_iter_fn fn,
                                            void *data)
{
        struct pmu_event pe = {
                .pmu = &big_c_string[pmu->pmu_name.offset],
        };
        int low = 0, high = pmu->num_entries - 1;

        while (low <= high) {
                int cmp, mid = (low + high) / 2;

                decompress_event(pmu->entries[mid].offset, &pe);

                if (!pe.name && !name)
                        goto do_call;

                if (!pe.name && name) {
                        low = mid + 1;
                        continue;
                }
                if (pe.name && !name) {
                        high = mid - 1;
                        continue;
                }

                cmp = strcasecmp(pe.name, name);
                if (cmp < 0) {
                        low = mid + 1;
                        continue;
                }
                if (cmp > 0) {
                        high = mid - 1;
                        continue;
                }
  do_call:
                return fn ? fn(&pe, table, data) : 0;
        }
        return PMU_EVENTS__NOT_FOUND;
}

int pmu_events_table__for_each_event(const struct pmu_events_table *table,
                                    struct perf_pmu *pmu,
                                    pmu_event_iter_fn fn,
                                    void *data)
{
        for (size_t i = 0; i < table->num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &table->pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];
                int ret;

                if (pmu && !perf_pmu__name_wildcard_match(pmu, pmu_name))
                        continue;

                ret = pmu_events_table__for_each_event_pmu(table, table_pmu, fn, data);
                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_events_table__find_event(const struct pmu_events_table *table,
                                 struct perf_pmu *pmu,
                                 const char *name,
                                 pmu_event_iter_fn fn,
                                 void *data)
{
        for (size_t i = 0; i < table->num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &table->pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];
                int ret;

                if (!perf_pmu__name_wildcard_match(pmu, pmu_name))
                        continue;

                ret = pmu_events_table__find_event_pmu(table, table_pmu, name, fn, data);
                if (ret != PMU_EVENTS__NOT_FOUND)
                        return ret;
        }
        return PMU_EVENTS__NOT_FOUND;
}

size_t pmu_events_table__num_events(const struct pmu_events_table *table,
                                    struct perf_pmu *pmu)
{
        size_t count = 0;

        for (size_t i = 0; i < table->num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &table->pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];

                if (perf_pmu__name_wildcard_match(pmu, pmu_name))
                        count += table_pmu->num_entries;
        }
        return count;
}

static int pmu_metrics_table__for_each_metric_pmu(const struct pmu_metrics_table *table,
                                                const struct pmu_table_entry *pmu,
                                                pmu_metric_iter_fn fn,
                                                void *data)
{
        int ret;
        struct pmu_metric pm = {
                .pmu = &big_c_string[pmu->pmu_name.offset],
        };

        for (uint32_t i = 0; i < pmu->num_entries; i++) {
                decompress_metric(pmu->entries[i].offset, &pm);
                if (!pm.metric_expr)
                        continue;
                ret = fn(&pm, table, data);
                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_metrics_table__for_each_metric(const struct pmu_metrics_table *table,
                                     pmu_metric_iter_fn fn,
                                     void *data)
{
        for (size_t i = 0; i < table->num_pmus; i++) {
                int ret = pmu_metrics_table__for_each_metric_pmu(table, &table->pmus[i],
                                                                 fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

static const struct pmu_events_map *map_for_cpu(struct perf_cpu cpu)
{
        static struct {
                const struct pmu_events_map *map;
                struct perf_cpu cpu;
        } last_result;
        static struct {
                const struct pmu_events_map *map;
                char *cpuid;
        } last_map_search;
        static bool has_last_result, has_last_map_search;
        const struct pmu_events_map *map = NULL;
        char *cpuid = NULL;
        size_t i;

        if (has_last_result && last_result.cpu.cpu == cpu.cpu)
                return last_result.map;

        cpuid = get_cpuid_allow_env_override(cpu);

        /*
         * On some platforms which uses cpus map, cpuid can be NULL for
         * PMUs other than CORE PMUs.
         */
        if (!cpuid)
                goto out_update_last_result;

        if (has_last_map_search && !strcmp(last_map_search.cpuid, cpuid)) {
                map = last_map_search.map;
                free(cpuid);
        } else {
                i = 0;
                for (;;) {
                        map = &pmu_events_map[i++];

                        if (!map->arch) {
                                map = NULL;
                                break;
                        }

                        if (!strcmp_cpuid_str(map->cpuid, cpuid))
                                break;
               }
               free(last_map_search.cpuid);
               last_map_search.cpuid = cpuid;
               last_map_search.map = map;
               has_last_map_search = true;
        }
out_update_last_result:
        last_result.cpu = cpu;
        last_result.map = map;
        has_last_result = true;
        return map;
}

static const struct pmu_events_map *map_for_pmu(struct perf_pmu *pmu)
{
        struct perf_cpu cpu = {-1};

        if (pmu)
                cpu = perf_cpu_map__min(pmu->cpus);
        return map_for_cpu(cpu);
}

const struct pmu_events_table *perf_pmu__find_events_table(struct perf_pmu *pmu)
{
        const struct pmu_events_map *map = map_for_pmu(pmu);

        if (!map)
                return NULL;

        if (!pmu)
                return &map->event_table;

        for (size_t i = 0; i < map->event_table.num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &map->event_table.pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];

                if (perf_pmu__name_wildcard_match(pmu, pmu_name))
                         return &map->event_table;
        }
        return NULL;
}

const struct pmu_metrics_table *pmu_metrics_table__find(void)
{
        struct perf_cpu cpu = {-1};
        const struct pmu_events_map *map = map_for_cpu(cpu);

        return map ? &map->metric_table : NULL;
}

const struct pmu_events_table *find_core_events_table(const char *arch, const char *cpuid)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                if (!strcmp(tables->arch, arch) && !strcmp_cpuid_str(tables->cpuid, cpuid))
                        return &tables->event_table;
        }
        return NULL;
}

const struct pmu_metrics_table *find_core_metrics_table(const char *arch, const char *cpuid)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                if (!strcmp(tables->arch, arch) && !strcmp_cpuid_str(tables->cpuid, cpuid))
                        return &tables->metric_table;
        }
        return NULL;
}

int pmu_for_each_core_event(pmu_event_iter_fn fn, void *data)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                int ret = pmu_events_table__for_each_event(&tables->event_table,
                                                           /*pmu=*/ NULL, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_for_each_core_metric(pmu_metric_iter_fn fn, void *data)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                int ret = pmu_metrics_table__for_each_metric(&tables->metric_table, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

const struct pmu_events_table *find_sys_events_table(const char *name)
{
        for (const struct pmu_sys_events *tables = &pmu_sys_event_tables[0];
             tables->name;
             tables++) {
                if (!strcmp(tables->name, name))
                        return &tables->event_table;
        }
        return NULL;
}

int pmu_for_each_sys_event(pmu_event_iter_fn fn, void *data)
{
        for (const struct pmu_sys_events *tables = &pmu_sys_event_tables[0];
             tables->name;
             tables++) {
                int ret = pmu_events_table__for_each_event(&tables->event_table,
                                                           /*pmu=*/ NULL, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_for_each_sys_metric(pmu_metric_iter_fn fn, void *data)
{
        for (const struct pmu_sys_events *tables = &pmu_sys_event_tables[0];
             tables->name;
             tables++) {
                int ret = pmu_metrics_table__for_each_metric(&tables->metric_table, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

static const int metricgroups[][2] = {

};

const char *describe_metricgroup(const char *group)
{
        int low = 0, high = (int)ARRAY_SIZE(metricgroups) - 1;

        while (low <= high) {
                int mid = (low + high) / 2;
                const char *mgroup = &big_c_string[metricgroups[mid][0]];
                int cmp = strcmp(mgroup, group);

                if (cmp == 0) {
                        return &big_c_string[metricgroups[mid][1]];
                } else if (cmp < 0) {
                        low = mid + 1;
                } else {
                        high = mid - 1;
                }
        }
        return NULL;
}
